diff -pruN 13.2.0-19/debian/changelog 13.2.0-20/debian/changelog
--- 13.2.0-19/debian/changelog	2024-03-15 16:33:18.000000000 +0000
+++ 13.2.0-20/debian/changelog	2024-03-23 10:38:07.000000000 +0000
@@ -1,9 +1,36 @@
+gcc-13 (13.2.0-20) unstable; urgency=medium
+
+  * Update to git 20240323 from the gcc-13 branch.
+    - Fix PR other/109668, PR tree-optimization/114231,
+      PR tree-optimization/112793, PR tree-optimization/113670,
+      PR middle-end/113622, PR tree-optimization/114203, PR middle-end/114070,
+      PR middle-end/114070, PR tree-optimization/114027, PR debug/112718,
+      PR tree-optimization/113910, PR tree-optimization/111736,
+      PR tree-optimization/114396, PR target/113950 (PPC),
+      PR target/111822 (x86), PR target/114160 (RISCV), PR sanitizer/112709,
+      PR sanitizer/112709, PR target/114339 (x86), PR middle-end/113907,
+      PR target/114310 (AArch64), PR rtl-optimization/110079,
+      PR rtl-optimization/114211, PR target/114184 (x86), PR fortran/114001,
+      PR fortran/103715, PR fortran/110826, PR fortran/100988,
+      PR fortran/104819, PR libstdc++/66146, PR libstdc++/114316,
+      PR libstdc++/114147.
+  * Make vhdl known to the PPC backend.
+  * Use the proposed patch to fix PR ada/114064, 64bit definitions for
+    time_t_bits type on 32bit archs.
+  * libsanitizer: Remove crypt and crypt_r interceptors for releases
+    with glibc (>= 2.31). Remove the build hacks for crypt.h.
+  * libstdc++-dev: Install libstdc++_libbacktrace.a. Note that all Filesystem TS
+    and std::stacktrace symbols were added to libstdc++exp.a and GCC 14 stops
+    shipping libstdc++_libbacktrace.a. Closes: #1065359.
+
+ -- Matthias Klose <doko@debian.org>  Sat, 23 Mar 2024 11:38:07 +0100
+
 gcc-13 (13.2.0-19) unstable; urgency=medium
 
   * Update to git 20240315 from the gcc-13 branch.
     - Fix PR middle-end/95351, PR driver/114314, PR target/101737 (SH),
       PR ada/113979, PR d/112285, PR d/112290, PR d/114171, PR fortran/114012,
-      PR fortran/114024, PR libfortran/105437, PR libfortran/114304, 
+      PR fortran/114024, PR libfortran/105437, PR libfortran/114304,
       PR libfortran/105473, PR libstdc++/110167.
   * Fix installation of the amdgcn offload compiler.
   * Fix installation of the nvptx offload compiler. Closes: #1065598.
diff -pruN 13.2.0-19/debian/patches/gcc-vhdl.diff 13.2.0-20/debian/patches/gcc-vhdl.diff
--- 13.2.0-19/debian/patches/gcc-vhdl.diff	1970-01-01 00:00:00.000000000 +0000
+++ 13.2.0-20/debian/patches/gcc-vhdl.diff	2024-03-23 10:28:42.000000000 +0000
@@ -0,0 +1,15 @@
+# DP: Make vhdl known to the PPC backend. See 
+# DP: https://github.com/ghdl/ghdl/blob/master/doc/development/building/GCC.rst
+
+--- a/src/gcc/config/rs6000/rs6000-logue.cc
++++ b/src/gcc/config/rs6000/rs6000-logue.cc
+@@ -5351,7 +5351,8 @@
+ 	  || ! strcmp (language_string, "GNU Go")
+ 	  || ! strcmp (language_string, "GNU D")
+ 	  || ! strcmp (language_string, "GNU Rust")
+-	  || ! strcmp (language_string, "libgccjit"))
++	  || ! strcmp (language_string, "libgccjit")
++	  || ! strcmp (language_string, "vhdl"))
+ 	i = 0;
+       else if (! strcmp (language_string, "GNU F77")
+ 	       || lang_GNU_Fortran ())
diff -pruN 13.2.0-19/debian/patches/git-doc-updates.diff 13.2.0-20/debian/patches/git-doc-updates.diff
--- 13.2.0-19/debian/patches/git-doc-updates.diff	2024-03-15 02:19:05.000000000 +0000
+++ 13.2.0-20/debian/patches/git-doc-updates.diff	2024-03-23 10:31:02.000000000 +0000
@@ -1,7 +1,7 @@
-# DP: updates from the 13 branch upto 20240315 (documentation).
+# DP: updates from the 13 branch upto 20240323 (documentation).
 
 LANG=C git diff --no-renames --src-prefix=a/src/ --dst-prefix=b/src/ \
-	c891d8dc23e1a46ad9f3e757d09e57b500d40044 7d2d6e1ab566f8fa5e87028b7ab9da8d5d0a1369 \
+	c891d8dc23e1a46ad9f3e757d09e57b500d40044 3c9e486f9248dd3c778d5e1a902727c8e53b226f \
 	| awk '/^diff .*\.texi/ {skip=0; print; next} /^diff / {skip=1; next} skip==0' \
         | grep -v -E '^(diff|index)'
 
diff -pruN 13.2.0-19/debian/patches/git-updates.diff 13.2.0-20/debian/patches/git-updates.diff
--- 13.2.0-19/debian/patches/git-updates.diff	2024-03-15 02:19:05.000000000 +0000
+++ 13.2.0-20/debian/patches/git-updates.diff	2024-03-23 10:31:29.000000000 +0000
@@ -1,10 +1,52 @@
-# DP: updates from the 13 branch upto 20240315 (7d2d6e1ab56).
+# DP: updates from the 13 branch upto 20240323 (3c9e486f924).
 
 LANG=C git diff --no-renames --src-prefix=a/src/ --dst-prefix=b/src/ \
-	c891d8dc23e1a46ad9f3e757d09e57b500d40044 7d2d6e1ab566f8fa5e87028b7ab9da8d5d0a1369 \
+	c891d8dc23e1a46ad9f3e757d09e57b500d40044 3c9e486f9248dd3c778d5e1a902727c8e53b226f \
 	| awk '/^diff .*\.texi/ {skip=1; next} /^diff / { skip=0 } skip==0' \
 	| grep -v -E '^(diff|index)'
 
+--- a/src/contrib/ChangeLog
++++ b/src/contrib/ChangeLog
+@@ -1,3 +1,12 @@
++2024-03-15  Sam James  <sam@gentoo.org>
++
++	Backported from master:
++	2024-03-08  Sam James  <sam@gentoo.org>
++
++	PR other/109668
++	* dg-extract-results.sh: Check for python3 before python. Check for
++	python2 last.
++
+ 2023-07-27  Release Manager
+ 
+ 	* GCC 13.2.0 released.
+--- a/src/contrib/dg-extract-results.sh
++++ b/src/contrib/dg-extract-results.sh
+@@ -28,14 +28,17 @@
+ 
+ PROGNAME=dg-extract-results.sh
+ 
+-# Try to use the python version if possible, since it tends to be faster.
++# Try to use the python version if possible, since it tends to be faster and
++# produces more stable results.
+ PYTHON_VER=`echo "$0" | sed 's/sh$/py/'`
+-if test "$PYTHON_VER" != "$0" &&
+-   test -f "$PYTHON_VER" &&
+-   python -c 'import sys, getopt, re, io, datetime, operator; sys.exit (0 if sys.version_info >= (2, 6) else 1)' \
+-     > /dev/null 2> /dev/null; then
+-  exec python $PYTHON_VER "$@"
+-fi
++for python in python3 python python2 ; do
++  if test "$PYTHON_VER" != "$0" &&
++     test -f "$PYTHON_VER" &&
++     ${python} -c 'import sys, getopt, re, io, datetime, operator; sys.exit (0 if sys.version_info >= (2, 6) else 1)' \
++       > /dev/null 2> /dev/null; then
++    exec ${python} $PYTHON_VER "$@"
++  fi
++done
+ 
+ usage() {
+   cat <<EOF >&2
 --- a/src/fixincludes/ChangeLog
 +++ b/src/fixincludes/ChangeLog
 @@ -1,3 +1,10 @@
@@ -81,7 +123,249 @@ LANG=C git diff --no-renames --src-prefi
  
 --- a/src/gcc/ChangeLog
 +++ b/src/gcc/ChangeLog
-@@ -1,3 +1,1959 @@
+@@ -1,3 +1,2201 @@
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/114231
++	* tree-vect-slp.cc (vect_analyze_slp): Lookup patterns when
++	processing a BB SLP root.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2023-12-14  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/112793
++	* tree-vect-slp.cc (vect_schedule_slp_node): Already
++	code-generated constant/external nodes are OK.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-01-31  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/113670
++	* tree-vect-data-refs.cc (vect_check_gather_scatter):
++	Make sure we can take the address of the reference base.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-01-29  Richard Biener  <rguenther@suse.de>
++
++	PR middle-end/113622
++	* gimple-isel.cc (gimple_expand_vec_set_extract_expr):
++	Also allow DECL_HARD_REGISTER variables.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-03-04  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/114203
++	* tree-ssa-loop-niter.cc (build_cltz_expr): Apply CTZ->CLZ
++	adjustment before making the result defined at zero.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-03-01  Richard Biener  <rguenther@suse.de>
++
++	PR middle-end/114070
++	* match.pd ((c ? a : b) op d  -->  c ? (a op d) : (b op d)):
++	Allow the folding if before lowering and the current IL
++	isn't supported with vcond_mask.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-02-26  Richard Biener  <rguenther@suse.de>
++
++	PR middle-end/114070
++	* genmatch.cc (parser::parse_c_expr): Do not record operand
++	lists but only mark operators used.
++	* match.pd ((c ? a : b) op (c ? d : e)  -->  c ? (a op d) : (b op e)):
++	Properly guard the case of tcc_comparison changing the VEC_COND
++	value operand type.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-02-22  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/114027
++	* tree-vect-loop.cc (vecctorizable_reduction): Use optimized
++	condition reduction classification only for single-element
++	chains.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-02-14  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/113910
++	* bitmap.cc (bitmap_hash): Mix the full element "hash" to
++	the hashval_t hash.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-01-23  Richard Biener  <rguenther@suse.de>
++
++	PR debug/112718
++	* dwarf2out.cc (dwarf2out_finish): Reset all type units
++	for the fat part of an LTO compile.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/111736
++	* asan.cc (instrument_derefs): Do not instrument accesses
++	to non-generic address-spaces.
++
++2024-03-21  liuhongt  <hongtao.liu@intel.com>
++
++	Backported from master:
++	2024-03-21  liuhongt  <hongtao.liu@intel.com>
++
++	PR tree-optimization/114396
++	* tree-vect-loop.cc (vect_peel_nonlinear_iv_init): Pass utype
++	and true to wi::from_mpz.
++
++2024-03-21  Jeevitha  <jeevitha@linux.ibm.com>
++
++	Backported from master:
++	2024-03-07  Jeevitha Palanisamy  <jeevitha@linux.ibm.com>
++
++	PR target/113950
++	* config/rs6000/vsx.md (vsx_splat_<mode>): Correct assignment to operand1
++	and simplify else if with else.
++
++2024-03-19  Uros Bizjak  <ubizjak@gmail.com>
++
++	PR target/111822
++	* config/i386/i386-features.cc (smode_convert_cst): New function
++	to handle SImode, DImode and TImode immediates.
++	(scalar_chain::convert_op): Unify from
++	general_scalar_chain::convert_op and timode_scalar_chain::convert_op.
++	(general_scalar_chain::convert_op): Remove.
++	(timode_scalar_chain::convert_op): Remove.
++	* config/i386/i386-features.h (class scalar_chain):
++	Redeclare convert_op as protected class member.
++	(class general_calar_chain): Remove convert_op.
++	(class timode_scalar_chain): Ditto.
++
++2024-03-18  Christoph Müllner  <christoph.muellner@vrull.eu>
++
++	Backported from master:
++	2023-07-12  Christoph Müllner  <christoph.muellner@vrull.eu>
++
++	PR target/114160
++	* config/riscv/thead.cc (th_mempair_save_regs):
++	Emit REG_FRAME_RELATED_EXPR notes in prologue.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-14  Jakub Jelinek  <jakub@redhat.com>
++
++	* gimple-iterator.cc (edge_before_returns_twice_call): Copy all
++	flags and probability from ad_edge to e edge.  If CDI_DOMINATORS
++	are computed, recompute immediate dominator of other_edge->src
++	and other_edge->dest.
++	(gsi_safe_insert_before, gsi_safe_insert_seq_before): Update *iter
++	for the returns_twice call case to the gsi_for_stmt (stmt) to deal
++	with update it for bb splitting.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-13  Jakub Jelinek  <jakub@redhat.com>
++
++	PR sanitizer/112709
++	* asan.cc (maybe_create_ssa_name, maybe_cast_to_ptrmode,
++	build_check_stmt, maybe_instrument_call, asan_expand_mark_ifn): Use
++	gsi_safe_insert_before instead of gsi_insert_before.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-13  Jakub Jelinek  <jakub@redhat.com>
++
++	PR sanitizer/112709
++	* gimple-iterator.h (gsi_safe_insert_before,
++	gsi_safe_insert_seq_before): Declare.
++	* gimple-iterator.cc: Include gimplify.h.
++	(edge_before_returns_twice_call, adjust_before_returns_twice_call,
++	gsi_safe_insert_before, gsi_safe_insert_seq_before): New functions.
++	* ubsan.cc (instrument_mem_ref, instrument_pointer_overflow,
++	instrument_nonnull_arg, instrument_nonnull_return): Use
++	gsi_safe_insert_before instead of gsi_insert_before.
++	(maybe_instrument_pointer_overflow): Use force_gimple_operand,
++	gimple_seq_add_seq_without_update and gsi_safe_insert_seq_before
++	instead of force_gimple_operand_gsi.
++	(instrument_object_size): Likewise.  Use gsi_safe_insert_before
++	instead of gsi_insert_before.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	PR target/114339
++	* config/i386/i386-expand.cc (ix86_expand_int_sse_cmp) <case LE>: Fix
++	a pasto, compare code against LE rather than GE.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-14  Jakub Jelinek  <jakub@redhat.com>
++
++	PR middle-end/113907
++	* ipa-icf.cc (sem_item_optimizer::merge_classes): Reset
++	SSA_NAME_RANGE_INFO and SSA_NAME_PTR_INFO on successfully ICF merged
++	functions.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-14  Jakub Jelinek  <jakub@redhat.com>
++
++	PR target/114310
++	* config/aarch64/aarch64.cc (aarch64_expand_compare_and_swap): For
++	TImode force newval into a register.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-07  Jakub Jelinek  <jakub@redhat.com>
++
++	PR rtl-optimization/110079
++	* bb-reorder.cc (fix_crossing_unconditional_branches): Don't adjust
++	asm goto.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-05  Jakub Jelinek  <jakub@redhat.com>
++
++	PR rtl-optimization/114211
++	* lower-subreg.cc (resolve_simple_move): For double-word
++	rotates by BITS_PER_WORD if there is overlap between source
++	and destination use a temporary.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-04  Jakub Jelinek  <jakub@redhat.com>
++
++	PR target/114184
++	* config/i386/i386-expand.cc (ix86_expand_move): If XFmode op1
++	is SUBREG of CONSTANT_P, force the SUBREG_REG into memory or
++	register.
++
 +2024-03-14  liuhongt  <hongtao.liu@intel.com>
 +
 +	Backported from master:
@@ -2045,7 +2329,7 @@ LANG=C git diff --no-renames --src-prefi
 +++ b/src/gcc/DATESTAMP
 @@ -1 +1 @@
 -20230727
-+20240315
++20240323
 --- a/src/gcc/ada/ChangeLog
 +++ b/src/gcc/ada/ChangeLog
 @@ -1,3 +1,599 @@
@@ -7612,6 +7896,62 @@ LANG=C git diff --no-renames --src-prefi
        || DECL_SIZE (decl) == 0
        || ASAN_RED_ZONE_SIZE * BITS_PER_UNIT > MAX_OFILE_ALIGNMENT
        || TREE_CODE (DECL_SIZE_UNIT (decl)) != INTEGER_CST
+@@ -2569,7 +2571,7 @@ maybe_create_ssa_name (location_t loc, tree base, gimple_stmt_iterator *iter,
+   gimple *g = gimple_build_assign (make_ssa_name (TREE_TYPE (base)), base);
+   gimple_set_location (g, loc);
+   if (before_p)
+-    gsi_insert_before (iter, g, GSI_SAME_STMT);
++    gsi_safe_insert_before (iter, g);
+   else
+     gsi_insert_after (iter, g, GSI_NEW_STMT);
+   return gimple_assign_lhs (g);
+@@ -2588,7 +2590,7 @@ maybe_cast_to_ptrmode (location_t loc, tree len, gimple_stmt_iterator *iter,
+ 				  NOP_EXPR, len);
+   gimple_set_location (g, loc);
+   if (before_p)
+-    gsi_insert_before (iter, g, GSI_SAME_STMT);
++    gsi_safe_insert_before (iter, g);
+   else
+     gsi_insert_after (iter, g, GSI_NEW_STMT);
+   return gimple_assign_lhs (g);
+@@ -2679,7 +2681,7 @@ build_check_stmt (location_t loc, tree base, tree len,
+ 						 align / BITS_PER_UNIT));
+   gimple_set_location (g, loc);
+   if (before_p)
+-    gsi_insert_before (&gsi, g, GSI_SAME_STMT);
++    gsi_safe_insert_before (&gsi, g);
+   else
+     {
+       gsi_insert_after (&gsi, g, GSI_NEW_STMT);
+@@ -2750,6 +2752,10 @@ instrument_derefs (gimple_stmt_iterator *iter, tree t,
+   if (VAR_P (inner) && DECL_HARD_REGISTER (inner))
+     return;
+ 
++  /* Accesses to non-generic address-spaces should not be instrumented.  */
++  if (!ADDR_SPACE_GENERIC_P (TYPE_ADDR_SPACE (TREE_TYPE (inner))))
++    return;
++
+   poly_int64 decl_size;
+   if ((VAR_P (inner) || TREE_CODE (inner) == RESULT_DECL)
+       && offset == NULL_TREE
+@@ -3018,7 +3024,7 @@ maybe_instrument_call (gimple_stmt_iterator *iter)
+ 	  tree decl = builtin_decl_implicit (BUILT_IN_ASAN_HANDLE_NO_RETURN);
+ 	  gimple *g = gimple_build_call (decl, 0);
+ 	  gimple_set_location (g, gimple_location (stmt));
+-	  gsi_insert_before (iter, g, GSI_SAME_STMT);
++	  gsi_safe_insert_before (iter, g);
+ 	}
+     }
+ 
+@@ -3842,7 +3848,7 @@ asan_expand_mark_ifn (gimple_stmt_iterator *iter)
+       g = gimple_build_assign (make_ssa_name (pointer_sized_int_node),
+ 			       NOP_EXPR, len);
+       gimple_set_location (g, loc);
+-      gsi_insert_before (iter, g, GSI_SAME_STMT);
++      gsi_safe_insert_before (iter, g);
+       tree sz_arg = gimple_assign_lhs (g);
+ 
+       tree fun
 --- a/src/gcc/attribs.cc
 +++ b/src/gcc/attribs.cc
 @@ -109,15 +109,6 @@ static const struct attribute_spec empty_attribute_table[] =
@@ -7662,6 +8002,29 @@ LANG=C git diff --no-renames --src-prefi
  	continue;
  
        if (spec->handler != NULL)
+--- a/src/gcc/bb-reorder.cc
++++ b/src/gcc/bb-reorder.cc
+@@ -2266,7 +2266,8 @@ fix_crossing_unconditional_branches (void)
+ 	  /* Make sure the jump is not already an indirect or table jump.  */
+ 
+ 	  if (!computed_jump_p (last_insn)
+-	      && !tablejump_p (last_insn, NULL, NULL))
++	      && !tablejump_p (last_insn, NULL, NULL)
++	      && asm_noperands (PATTERN (last_insn)) < 0)
+ 	    {
+ 	      /* We have found a "crossing" unconditional branch.  Now
+ 		 we must convert it to an indirect jump.  First create
+--- a/src/gcc/bitmap.cc
++++ b/src/gcc/bitmap.cc
+@@ -2673,7 +2673,7 @@ bitmap_hash (const_bitmap head)
+       for (ix = 0; ix != BITMAP_ELEMENT_WORDS; ix++)
+ 	hash ^= ptr->bits[ix];
+     }
+-  return (hashval_t)hash;
++  return iterative_hash (&hash, sizeof (hash), 0);
+ }
+ 
+ 
 --- a/src/gcc/c-family/ChangeLog
 +++ b/src/gcc/c-family/ChangeLog
 @@ -1,3 +1,54 @@
@@ -9458,7 +9821,16 @@ LANG=C git diff --no-renames --src-prefi
  }
  
  
-@@ -24801,10 +24862,11 @@ aarch64_copy_one_block_and_progress_pointers (rtx *src, rtx *dst,
+@@ -23020,6 +23081,8 @@ aarch64_expand_compare_and_swap (rtx operands[])
+         rval = copy_to_mode_reg (r_mode, oldval);
+       else
+ 	emit_move_insn (rval, gen_lowpart (r_mode, oldval));
++      if (mode == TImode)
++	newval = force_reg (mode, newval);
+ 
+       emit_insn (gen_aarch64_compare_and_swap_lse (mode, rval, mem,
+ 						   newval, mod_s));
+@@ -24801,10 +24864,11 @@ aarch64_copy_one_block_and_progress_pointers (rtx *src, rtx *dst,
    *dst = aarch64_progress_pointer (*dst);
  }
  
@@ -9474,7 +9846,7 @@ LANG=C git diff --no-renames --src-prefi
  {
    if (!TARGET_MOPS)
      return false;
-@@ -24816,8 +24878,10 @@ aarch64_expand_cpymem_mops (rtx *operands)
+@@ -24816,8 +24880,10 @@ aarch64_expand_cpymem_mops (rtx *operands)
    rtx dst_mem = replace_equiv_address (operands[0], dst_addr);
    rtx src_mem = replace_equiv_address (operands[1], src_addr);
    rtx sz_reg = copy_to_mode_reg (DImode, operands[2]);
@@ -9487,7 +9859,7 @@ LANG=C git diff --no-renames --src-prefi
    return true;
  }
  
-@@ -26104,11 +26168,9 @@ aarch64_operands_ok_for_ldpstp (rtx *operands, bool load,
+@@ -26104,11 +26170,9 @@ aarch64_operands_ok_for_ldpstp (rtx *operands, bool load,
    gcc_assert (known_eq (GET_MODE_SIZE (GET_MODE (mem_1)),
  			GET_MODE_SIZE (GET_MODE (mem_2))));
  
@@ -10770,7 +11142,40 @@ LANG=C git diff --no-renames --src-prefi
        break;
 --- a/src/gcc/config/i386/i386-expand.cc
 +++ b/src/gcc/config/i386/i386-expand.cc
-@@ -13720,6 +13720,25 @@ ix86_expand_builtin (tree exp, rtx target, rtx subtarget,
+@@ -429,6 +429,23 @@ ix86_expand_move (machine_mode mode, rtx operands[])
+ 
+     default:
+       break;
++
++    case SUBREG:
++      /* As not all values in XFmode are representable in real_value,
++	 we might be called with unfoldable SUBREGs of constants.  */
++      if (mode == XFmode
++	  && CONSTANT_P (SUBREG_REG (op1))
++	  && can_create_pseudo_p ())
++	{
++	  machine_mode imode = GET_MODE (SUBREG_REG (op1));
++	  rtx r = force_const_mem (imode, SUBREG_REG (op1));
++	  if (r)
++	    r = validize_mem (r);
++	  else
++	    r = force_reg (imode, SUBREG_REG (op1));
++	  op1 = simplify_gen_subreg (mode, r, imode, SUBREG_BYTE (op1));
++	}
++      break;
+     }
+ 
+   if ((flag_pic || MACHOPIC_INDIRECT)
+@@ -4565,7 +4582,7 @@ ix86_expand_int_sse_cmp (rtx dest, enum rtx_code code, rtx cop0, rtx cop1,
+ 		  rtx elt = CONST_VECTOR_ELT (cop1, i);
+ 		  if (!CONST_INT_P (elt))
+ 		    break;
+-		  if (code == GE)
++		  if (code == LE)
+ 		    {
+ 		      /* For LE punt if some element is signed maximum.  */
+ 		      if ((INTVAL (elt) & (GET_MODE_MASK (eltmode) >> 1))
+@@ -13720,6 +13737,25 @@ ix86_expand_builtin (tree exp, rtx target, rtx subtarget,
  	emit_insn (pat);
        return 0;
  
@@ -10798,29 +11203,67 @@ LANG=C git diff --no-renames --src-prefi
        op0 = expand_normal (arg0);
 --- a/src/gcc/config/i386/i386-features.cc
 +++ b/src/gcc/config/i386/i386-features.cc
-@@ -913,20 +913,36 @@ general_scalar_chain::convert_op (rtx *op, rtx_insn *insn)
+@@ -896,14 +896,35 @@ scalar_chain::convert_reg (rtx_insn *insn, rtx dst, rtx src)
+ 	     REGNO (src), REGNO (dst), INSN_UID (insn));
+ }
+ 
++/* Helper function to convert immediate constant X to vmode.  */
++static rtx
++smode_convert_cst (rtx x, enum machine_mode vmode)
++{
++  /* Prefer all ones vector in case of -1.  */
++  if (constm1_operand (x, GET_MODE (x)))
++    return CONSTM1_RTX (vmode);
++
++  unsigned n = GET_MODE_NUNITS (vmode);
++  rtx *v = XALLOCAVEC (rtx, n);
++  v[0] = x;
++  for (unsigned i = 1; i < n; ++i)
++    v[i] = const0_rtx;
++  return gen_rtx_CONST_VECTOR (vmode, gen_rtvec_v (n, v));
++}
++
+ /* Convert operand OP in INSN.  We should handle
+    memory operands and uninitialized registers.
+    All other register uses are converted during
+    registers conversion.  */
+ 
+ void
+-general_scalar_chain::convert_op (rtx *op, rtx_insn *insn)
++scalar_chain::convert_op (rtx *op, rtx_insn *insn)
+ {
++  rtx tmp;
++
++  if (GET_MODE (*op) == V1TImode)
++    return;
++
+   *op = copy_rtx_if_shared (*op);
+ 
+   if (GET_CODE (*op) == NOT)
+@@ -913,47 +934,48 @@ general_scalar_chain::convert_op (rtx *op, rtx_insn *insn)
      }
    else if (MEM_P (*op))
      {
-+      rtx_insn* eh_insn, *movabs = NULL;
-       rtx tmp = gen_reg_rtx (GET_MODE (*op));
+-      rtx tmp = gen_reg_rtx (GET_MODE (*op));
++      rtx_insn *movabs = NULL;
  
 -      /* Handle movabs.  */
 +      /* Emit MOVABS to load from a 64-bit absolute address to a GPR.  */
        if (!memory_operand (*op, GET_MODE (*op)))
  	{
- 	  rtx tmp2 = gen_reg_rtx (GET_MODE (*op));
-+	  movabs = emit_insn_before (gen_rtx_SET (tmp2, *op), insn);
+-	  rtx tmp2 = gen_reg_rtx (GET_MODE (*op));
++	  tmp = gen_reg_rtx (GET_MODE (*op));
++	  movabs = emit_insn_before (gen_rtx_SET (tmp, *op), insn);
++
++	  *op = tmp;
++	}
  
 -	  emit_insn_before (gen_rtx_SET (tmp2, *op), insn);
- 	  *op = tmp2;
- 	}
- 
--      emit_insn_before (gen_rtx_SET (gen_rtx_SUBREG (vmode, tmp, 0),
--				     gen_gpr_to_xmm_move_src (vmode, *op)),
--			insn);
-+      eh_insn
-+	= emit_insn_before (gen_rtx_SET (gen_rtx_SUBREG (vmode, tmp, 0),
+-	  *op = tmp2;
++      tmp = gen_rtx_SUBREG (vmode, gen_reg_rtx (GET_MODE (*op)), 0);
++
++      rtx_insn *eh_insn
++	= emit_insn_before (gen_rtx_SET (copy_rtx (tmp),
 +					 gen_gpr_to_xmm_move_src (vmode, *op)),
 +			    insn);
 +
@@ -10835,12 +11278,117 @@ LANG=C git diff --no-renames --src-prefi
 +	      control_flow_insns.safe_push (eh_insn);
 +	      add_reg_note (eh_insn, REG_EH_REGION, XEXP (note, 0));
 +	    }
-+	}
-+
-       *op = gen_rtx_SUBREG (vmode, tmp, 0);
+ 	}
+ 
+-      emit_insn_before (gen_rtx_SET (gen_rtx_SUBREG (vmode, tmp, 0),
+-				     gen_gpr_to_xmm_move_src (vmode, *op)),
+-			insn);
+-      *op = gen_rtx_SUBREG (vmode, tmp, 0);
++      *op = tmp;
  
        if (dump_file)
-@@ -2215,6 +2231,7 @@ convert_scalars_to_vector (bool timode_p)
+ 	fprintf (dump_file, "  Preloading operand for insn %d into r%d\n",
+ 		 INSN_UID (insn), REGNO (tmp));
+     }
+   else if (REG_P (*op))
++    *op = gen_rtx_SUBREG (vmode, *op, 0);
++  else if (CONST_SCALAR_INT_P (*op))
+     {
+-      *op = gen_rtx_SUBREG (vmode, *op, 0);
+-    }
+-  else if (CONST_INT_P (*op))
+-    {
+-      rtx vec_cst;
+-      rtx tmp = gen_rtx_SUBREG (vmode, gen_reg_rtx (smode), 0);
+-
+-      /* Prefer all ones vector in case of -1.  */
+-      if (constm1_operand (*op, GET_MODE (*op)))
+-	vec_cst = CONSTM1_RTX (vmode);
+-      else
+-	{
+-	  unsigned n = GET_MODE_NUNITS (vmode);
+-	  rtx *v = XALLOCAVEC (rtx, n);
+-	  v[0] = *op;
+-	  for (unsigned i = 1; i < n; ++i)
+-	    v[i] = const0_rtx;
+-	  vec_cst = gen_rtx_CONST_VECTOR (vmode, gen_rtvec_v (n, v));
+-	}
++      rtx vec_cst = smode_convert_cst (*op, vmode);
+ 
+       if (!standard_sse_constant_p (vec_cst, vmode))
+ 	{
+@@ -964,6 +986,8 @@ general_scalar_chain::convert_op (rtx *op, rtx_insn *insn)
+ 	  emit_insn_before (seq, insn);
+ 	}
+ 
++      tmp = gen_rtx_SUBREG (vmode, gen_reg_rtx (smode), 0);
++
+       emit_insn_before (gen_move_insn (copy_rtx (tmp), vec_cst), insn);
+       *op = tmp;
+     }
+@@ -1512,61 +1536,6 @@ timode_scalar_chain::fix_debug_reg_uses (rtx reg)
+     }
+ }
+ 
+-/* Convert operand OP in INSN from TImode to V1TImode.  */
+-
+-void
+-timode_scalar_chain::convert_op (rtx *op, rtx_insn *insn)
+-{
+-  *op = copy_rtx_if_shared (*op);
+-
+-  if (REG_P (*op))
+-    *op = gen_rtx_SUBREG (V1TImode, *op, 0);
+-  else if (MEM_P (*op))
+-    {
+-      rtx tmp = gen_reg_rtx (V1TImode);
+-      emit_insn_before (gen_rtx_SET (gen_rtx_SUBREG (V1TImode, tmp, 0),
+-				     gen_gpr_to_xmm_move_src (V1TImode, *op)),
+-			insn);
+-      *op = gen_rtx_SUBREG (V1TImode, tmp, 0);
+-
+-      if (dump_file)
+-	fprintf (dump_file, "  Preloading operand for insn %d into r%d\n",
+-		 INSN_UID (insn), REGNO (tmp));
+-    }
+-  else if (CONST_INT_P (*op))
+-    {
+-      rtx vec_cst;
+-      rtx tmp = gen_rtx_SUBREG (V1TImode, gen_reg_rtx (TImode), 0);
+-
+-      /* Prefer all ones vector in case of -1.  */
+-      if (constm1_operand (*op, TImode))
+-	vec_cst = CONSTM1_RTX (V1TImode);
+-      else
+-	{
+-	  rtx *v = XALLOCAVEC (rtx, 1);
+-	  v[0] = *op;
+-	  vec_cst = gen_rtx_CONST_VECTOR (V1TImode, gen_rtvec_v (1, v));
+-	}
+-
+-      if (!standard_sse_constant_p (vec_cst, V1TImode))
+-	{
+-	  start_sequence ();
+-	  vec_cst = validize_mem (force_const_mem (V1TImode, vec_cst));
+-	  rtx_insn *seq = get_insns ();
+-	  end_sequence ();
+-	  emit_insn_before (seq, insn);
+-	}
+-
+-      emit_insn_before (gen_move_insn (copy_rtx (tmp), vec_cst), insn);
+-      *op = tmp;
+-    }
+-  else
+-    {
+-      gcc_assert (SUBREG_P (*op));
+-      gcc_assert (GET_MODE (*op) == vmode);
+-    }
+-}
+-
+ /* Convert INSN from TImode to V1T1mode.  */
+ 
+ void
+@@ -2215,6 +2184,7 @@ convert_scalars_to_vector (bool timode_p)
  {
    basic_block bb;
    int converted_insns = 0;
@@ -10848,7 +11396,7 @@ LANG=C git diff --no-renames --src-prefi
  
    bitmap_obstack_initialize (NULL);
    const machine_mode cand_mode[3] = { SImode, DImode, TImode };
-@@ -2296,6 +2313,11 @@ convert_scalars_to_vector (bool timode_p)
+@@ -2296,6 +2266,11 @@ convert_scalars_to_vector (bool timode_p)
  			 chain->chain_id);
  	    }
  
@@ -10860,7 +11408,7 @@ LANG=C git diff --no-renames --src-prefi
  	  delete chain;
  	}
      }
-@@ -2364,6 +2386,24 @@ convert_scalars_to_vector (bool timode_p)
+@@ -2364,6 +2339,24 @@ convert_scalars_to_vector (bool timode_p)
  		  DECL_INCOMING_RTL (parm) = gen_rtx_SUBREG (TImode, r, 0);
  	      }
  	  }
@@ -10895,6 +11443,37 @@ LANG=C git diff --no-renames --src-prefi
  
    bool build (bitmap candidates, unsigned insn_uid, bitmap disallowed);
    virtual int compute_convert_gain () = 0;
+@@ -169,13 +170,13 @@ class scalar_chain
+   void convert_insn_common (rtx_insn *insn);
+   void make_vector_copies (rtx_insn *, rtx);
+   void convert_registers ();
++  void convert_op (rtx *op, rtx_insn *insn);
+ 
+  private:
+   bool add_insn (bitmap candidates, unsigned insn_uid, bitmap disallowed);
+   bool analyze_register_chain (bitmap candidates, df_ref ref,
+ 			       bitmap disallowed);
+   virtual void convert_insn (rtx_insn *insn) = 0;
+-  virtual void convert_op (rtx *op, rtx_insn *insn) = 0;
+ };
+ 
+ class general_scalar_chain : public scalar_chain
+@@ -187,7 +188,6 @@ class general_scalar_chain : public scalar_chain
+ 
+  private:
+   void convert_insn (rtx_insn *insn) final override;
+-  void convert_op (rtx *op, rtx_insn *insn) final override;
+   int vector_const_cost (rtx exp);
+ };
+ 
+@@ -200,7 +200,6 @@ class timode_scalar_chain : public scalar_chain
+  private:
+   void fix_debug_reg_uses (rtx reg);
+   void convert_insn (rtx_insn *insn) final override;
+-  void convert_op (rtx *op, rtx_insn *insn) final override;
+ };
+ 
+ } // anon namespace
 --- a/src/gcc/config/i386/i386-options.cc
 +++ b/src/gcc/config/i386/i386-options.cc
 @@ -128,10 +128,11 @@ along with GCC; see the file COPYING3.  If not see
@@ -12863,6 +13442,23 @@ LANG=C git diff --no-renames --src-prefi
  	$(COMPILER) -c $(ALL_COMPILERFLAGS) $(ALL_CPPFLAGS) $(INCLUDES) \
  		$(srcdir)/config/riscv/riscv-vsetvl.cc
  
+--- a/src/gcc/config/riscv/thead.cc
++++ b/src/gcc/config/riscv/thead.cc
+@@ -368,8 +368,12 @@ th_mempair_save_regs (rtx operands[4])
+   rtx set2 = gen_rtx_SET (operands[2], operands[3]);
+   rtx insn = emit_insn (gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2, set1, set2)));
+   RTX_FRAME_RELATED_P (insn) = 1;
+-  add_reg_note (insn, REG_CFA_OFFSET, copy_rtx (set1));
+-  add_reg_note (insn, REG_CFA_OFFSET, copy_rtx (set2));
++
++  REG_NOTES (insn) = alloc_EXPR_LIST (REG_FRAME_RELATED_EXPR,
++				      copy_rtx (set1), REG_NOTES (insn));
++
++  REG_NOTES (insn) = alloc_EXPR_LIST (REG_FRAME_RELATED_EXPR,
++				      copy_rtx (set2), REG_NOTES (insn));
+ }
+ 
+ /* Similar like riscv_restore_reg, but restores two registers from memory
 --- a/src/gcc/config/rs6000/mma.md
 +++ b/src/gcc/config/rs6000/mma.md
 @@ -293,8 +293,8 @@ (define_expand "movoo"
@@ -13240,6 +13836,17 @@ LANG=C git diff --no-renames --src-prefi
  }
 --- a/src/gcc/config/rs6000/vsx.md
 +++ b/src/gcc/config/rs6000/vsx.md
+@@ -4551,8 +4551,8 @@ (define_expand "vsx_splat_<mode>"
+   rtx op1 = operands[1];
+   if (MEM_P (op1))
+     operands[1] = rs6000_force_indexed_or_indirect_mem (op1);
+-  else if (!REG_P (op1))
+-    op1 = force_reg (<VSX_D:VEC_base>mode, op1);
++  else
++    operands[1] = force_reg (<VSX_D:VEC_base>mode, op1);
+ })
+ 
+ (define_insn "vsx_splat_<mode>_reg"
 @@ -6555,7 +6555,7 @@ (define_insn "xxeval"
  		      (match_operand:QI 4 "u8bit_cint_operand" "n")]
  		     UNSPEC_XXEVAL))]
@@ -15639,6 +16246,31 @@ LANG=C git diff --no-renames --src-prefi
        /* Type nodes are useful only when other DIEs reference them --- don't
  	 mark them.  */
        /* FALLTHROUGH */
+@@ -32184,24 +32191,12 @@ dwarf2out_finish (const char *filename)
+       reset_dies (comp_unit_die ());
+       for (limbo_die_node *node = cu_die_list; node; node = node->next)
+ 	reset_dies (node->die);
+-
+-      hash_table<comdat_type_hasher> comdat_type_table (100);
+       for (ctnode = comdat_type_list; ctnode != NULL; ctnode = ctnode->next)
+ 	{
+-	  comdat_type_node **slot
+-	      = comdat_type_table.find_slot (ctnode, INSERT);
+-
+-	  /* Don't reset types twice.  */
+-	  if (*slot != HTAB_EMPTY_ENTRY)
+-	    continue;
+-
+ 	  /* Remove the pointer to the line table.  */
+ 	  remove_AT (ctnode->root_die, DW_AT_stmt_list);
+-
+ 	  if (debug_info_level >= DINFO_LEVEL_TERSE)
+ 	    reset_dies (ctnode->root_die);
+-
+-	  *slot = ctnode;
+ 	}
+ 
+       /* Reset die CU symbol so we don't output it twice.  */
 --- a/src/gcc/fold-const.cc
 +++ b/src/gcc/fold-const.cc
 @@ -6223,7 +6223,6 @@ static tree
@@ -15669,7 +16301,61 @@ LANG=C git diff --no-renames --src-prefi
  	  op1 = gimple_assign_rhs1 (stmt);
 --- a/src/gcc/fortran/ChangeLog
 +++ b/src/gcc/fortran/ChangeLog
-@@ -1,3 +1,195 @@
+@@ -1,3 +1,249 @@
++2024-03-19  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2024-03-13  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/114001
++	* expr.cc (gfc_is_simply_contiguous): Adjust logic so that CLASS
++	symbols are also handled.
++
++2024-03-19  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2024-03-18  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/103715
++	* frontend-passes.cc (check_externals_expr): Prevent invalid read
++	in case of mismatch of external subroutine with function.
++
++2024-03-15  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2024-03-12  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/110826
++	* array.cc (gfc_array_dimen_size): When walking the ref chain of an
++	array and the ultimate component is a procedure pointer, do not try
++	to figure out its dimension even if it is a array-valued function.
++
++2024-03-15  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2023-12-05  Harald Anlauf  <anlauf@gmx.de>
++		    Tobias Burnus   <tobias@codesourcery.com>
++
++	PR fortran/100988
++	* gfortran.h (IS_PROC_POINTER): New macro.
++	* trans-types.cc (gfc_sym_type): Use macro in determination if the
++	restrict qualifier can be used for a dummy variable.  Fix logic to
++	allow the restrict qualifier also for optional arguments, and to
++	not apply it to pointer or proc_pointer arguments.
++
++2024-03-15  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2024-03-01  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/104819
++	* check.cc (gfc_check_null): Handle nested NULL()s.
++	(is_c_interoperable): Check for MOLD argument of NULL() as part of
++	the interoperability check.
++	* interface.cc (gfc_compare_actual_formal): Extend checks for NULL()
++	actual arguments for presence of MOLD argument when required by
++	Interp J3/22-146.
++
 +2024-03-06  Harald Anlauf  <anlauf@gmx.de>
 +
 +	Backported from master:
@@ -15865,6 +16551,43 @@ LANG=C git diff --no-renames --src-prefi
  2023-07-27  Release Manager
  
  	* GCC 13.2.0 released.
+--- a/src/gcc/fortran/array.cc
++++ b/src/gcc/fortran/array.cc
+@@ -2600,6 +2600,13 @@ gfc_array_dimen_size (gfc_expr *array, int dimen, mpz_t *result)
+     case EXPR_FUNCTION:
+       for (ref = array->ref; ref; ref = ref->next)
+ 	{
++	  /* Ultimate component is a procedure pointer.  */
++	  if (ref->type == REF_COMPONENT
++	      && !ref->next
++	      && ref->u.c.component->attr.function
++	      && IS_PROC_POINTER (ref->u.c.component))
++	    return false;
++
+ 	  if (ref->type != REF_ARRAY)
+ 	    continue;
+ 
+--- a/src/gcc/fortran/check.cc
++++ b/src/gcc/fortran/check.cc
+@@ -4357,6 +4357,9 @@ gfc_check_null (gfc_expr *mold)
+   if (mold == NULL)
+     return true;
+ 
++  if (mold->expr_type == EXPR_NULL)
++    return true;
++
+   if (!variable_check (mold, 0, true))
+     return false;
+ 
+@@ -5187,7 +5190,7 @@ is_c_interoperable (gfc_expr *expr, const char **msg, bool c_loc, bool c_f_ptr)
+ {
+   *msg = NULL;
+ 
+-  if (expr->expr_type == EXPR_NULL)
++  if (expr->expr_type == EXPR_NULL && expr->ts.type == BT_UNKNOWN)
+     {
+       *msg = "NULL() is not interoperable";
+       return false;
 --- a/src/gcc/fortran/decl.cc
 +++ b/src/gcc/fortran/decl.cc
 @@ -1957,6 +1957,45 @@ gfc_free_enum_history (void)
@@ -15972,6 +16695,34 @@ LANG=C git diff --no-renames --src-prefi
    c->as = *as;
    if (c->as != NULL)
      {
+--- a/src/gcc/fortran/expr.cc
++++ b/src/gcc/fortran/expr.cc
+@@ -5994,15 +5994,16 @@ gfc_is_simply_contiguous (gfc_expr *expr, bool strict, bool permit_element)
+     }
+ 
+   sym = expr->symtree->n.sym;
+-  if (expr->ts.type != BT_CLASS
+-      && ((part_ref
+-	   && !part_ref->u.c.component->attr.contiguous
+-	   && part_ref->u.c.component->attr.pointer)
+-	  || (!part_ref
+-	      && !sym->attr.contiguous
+-	      && (sym->attr.pointer
+-		  || (sym->as && sym->as->type == AS_ASSUMED_RANK)
+-		  || (sym->as && sym->as->type == AS_ASSUMED_SHAPE)))))
++  if ((part_ref
++       && part_ref->u.c.component
++       && !part_ref->u.c.component->attr.contiguous
++       && IS_POINTER (part_ref->u.c.component))
++      || (!part_ref
++	  && expr->ts.type != BT_CLASS
++	  && !sym->attr.contiguous
++	  && (sym->attr.pointer
++	      || (sym->as && sym->as->type == AS_ASSUMED_RANK)
++	      || (sym->as && sym->as->type == AS_ASSUMED_SHAPE))))
+     return false;
+ 
+   if (!ar || ar->type == AR_FULL)
 --- a/src/gcc/fortran/frontend-passes.cc
 +++ b/src/gcc/fortran/frontend-passes.cc
 @@ -1326,7 +1326,7 @@ traverse_io_block (gfc_code *code, bool *has_reached, gfc_code *prev)
@@ -15983,6 +16734,67 @@ LANG=C git diff --no-renames --src-prefi
  	    {
  	      if (iters[j]
  		  && (var_in_expr (var, iters[j]->start)
+@@ -5807,6 +5807,9 @@ check_externals_expr (gfc_expr **ep, int *walk_subtrees ATTRIBUTE_UNUSED,
+   if (e->expr_type != EXPR_FUNCTION)
+     return 0;
+ 
++  if (e->symtree && e->symtree->n.sym->attr.subroutine)
++    return 0;
++
+   sym = e->value.function.esym;
+   if (sym == NULL)
+     return 0;
+--- a/src/gcc/fortran/gfortran.h
++++ b/src/gcc/fortran/gfortran.h
+@@ -3951,6 +3951,9 @@ bool gfc_may_be_finalized (gfc_typespec);
+ #define IS_POINTER(sym) \
+ 	(sym->ts.type == BT_CLASS && sym->attr.class_ok && CLASS_DATA (sym) \
+ 	 ? CLASS_DATA (sym)->attr.class_pointer : sym->attr.pointer)
++#define IS_PROC_POINTER(sym) \
++	(sym->ts.type == BT_CLASS && sym->attr.class_ok && CLASS_DATA (sym) \
++	 ? CLASS_DATA (sym)->attr.proc_pointer : sym->attr.proc_pointer)
+ 
+ /* frontend-passes.cc */
+ 
+--- a/src/gcc/fortran/interface.cc
++++ b/src/gcc/fortran/interface.cc
+@@ -3259,6 +3259,36 @@ gfc_compare_actual_formal (gfc_actual_arglist **ap, gfc_formal_arglist *formal,
+ 	  && a->expr->ts.type != BT_ASSUMED)
+ 	gfc_find_vtab (&a->expr->ts);
+ 
++      /* Interp J3/22-146:
++	 "If the context of the reference to NULL is an <actual argument>
++	 corresponding to an <assumed-rank> dummy argument, MOLD shall be
++	 present."  */
++      if (a->expr->expr_type == EXPR_NULL
++	  && a->expr->ts.type == BT_UNKNOWN
++	  && f->sym->as
++	  && f->sym->as->type == AS_ASSUMED_RANK)
++	{
++	  gfc_error ("Intrinsic %<NULL()%> without %<MOLD%> argument at %L "
++		     "passed to assumed-rank dummy %qs",
++		     &a->expr->where, f->sym->name);
++	  ok = false;
++	  goto match;
++	}
++
++      if (a->expr->expr_type == EXPR_NULL
++	  && a->expr->ts.type == BT_UNKNOWN
++	  && f->sym->ts.type == BT_CHARACTER
++	  && !f->sym->ts.deferred
++	  && f->sym->ts.u.cl
++	  && f->sym->ts.u.cl->length == NULL)
++	{
++	  gfc_error ("Intrinsic %<NULL()%> without %<MOLD%> argument at %L "
++		     "passed to assumed-length dummy %qs",
++		     &a->expr->where, f->sym->name);
++	  ok = false;
++	  goto match;
++	}
++
+       if (a->expr->expr_type == EXPR_NULL
+ 	  && ((f->sym->ts.type != BT_CLASS && !f->sym->attr.pointer
+ 	       && (f->sym->attr.allocatable || !f->sym->attr.optional
 --- a/src/gcc/fortran/match.cc
 +++ b/src/gcc/fortran/match.cc
 @@ -5062,6 +5062,7 @@ gfc_match_call (void)
@@ -16483,6 +17295,35 @@ LANG=C git diff --no-renames --src-prefi
        if (code->expr3->expr_type == EXPR_VARIABLE
  	  || code->expr3->expr_type == EXPR_ARRAY
  	  || code->expr3->expr_type == EXPR_CONSTANT)
+--- a/src/gcc/fortran/trans-types.cc
++++ b/src/gcc/fortran/trans-types.cc
+@@ -2324,8 +2324,8 @@ gfc_sym_type (gfc_symbol * sym, bool is_bind_c)
+   else
+     byref = 0;
+ 
+-  restricted = !sym->attr.target && !sym->attr.pointer
+-               && !sym->attr.proc_pointer && !sym->attr.cray_pointee;
++  restricted = (!sym->attr.target && !IS_POINTER (sym)
++		&& !IS_PROC_POINTER (sym) && !sym->attr.cray_pointee);
+   if (!restricted)
+     type = gfc_nonrestricted_type (type);
+ 
+@@ -2381,11 +2381,10 @@ gfc_sym_type (gfc_symbol * sym, bool is_bind_c)
+ 	  || (sym->ns->proc_name && sym->ns->proc_name->attr.entry_master))
+ 	type = build_pointer_type (type);
+       else
+-	{
+-	  type = build_reference_type (type);
+-	  if (restricted)
+-	    type = build_qualified_type (type, TYPE_QUAL_RESTRICT);
+-	}
++	type = build_reference_type (type);
++
++      if (restricted)
++	type = build_qualified_type (type, TYPE_QUAL_RESTRICT);
+     }
+ 
+   return (type);
 --- a/src/gcc/function.cc
 +++ b/src/gcc/function.cc
 @@ -3650,7 +3650,8 @@ assign_parms (tree fndecl)
@@ -16495,6 +17336,21 @@ LANG=C git diff --no-renames --src-prefi
      {
        struct assign_parm_data_one data = {};
        assign_parms_setup_varargs (&all, &data, false);
+--- a/src/gcc/genmatch.cc
++++ b/src/gcc/genmatch.cc
+@@ -4519,10 +4519,8 @@ parser::parse_c_expr (cpp_ttype start)
+ 	    = (const char *)CPP_HASHNODE (token->val.node.node)->ident.str;
+ 	  if (strcmp (str, "return") == 0)
+ 	    fatal_at (token, "return statement not allowed in C expression");
+-	  id_base *idb = get_operator (str);
+-	  user_id *p;
+-	  if (idb && (p = dyn_cast<user_id *> (idb)) && p->is_oper_list)
+-	    record_operlist (token->src_loc, p);
++	  /* Mark user operators corresponding to 'str' as used.  */
++	  get_operator (str);
+ 	}
+ 
+       /* Record the token.  */
 --- a/src/gcc/ggc-common.cc
 +++ b/src/gcc/ggc-common.cc
 @@ -673,7 +673,7 @@ gt_pch_save (FILE *f)
@@ -16506,6 +17362,190 @@ LANG=C git diff --no-renames --src-prefi
        if (addr == last_addr)
  	continue;
        if (last_addr == NULL)
+--- a/src/gcc/gimple-isel.cc
++++ b/src/gcc/gimple-isel.cc
+@@ -77,7 +77,8 @@ gimple_expand_vec_set_expr (struct function *fun, gimple_stmt_iterator *gsi)
+       tree pos = TREE_OPERAND (lhs, 1);
+       tree view_op0 = TREE_OPERAND (op0, 0);
+       machine_mode outermode = TYPE_MODE (TREE_TYPE (view_op0));
+-      if (auto_var_in_fn_p (view_op0, fun->decl)
++      if ((auto_var_in_fn_p (view_op0, fun->decl)
++	   || (VAR_P (view_op0) && DECL_HARD_REGISTER (view_op0)))
+ 	  && !TREE_ADDRESSABLE (view_op0) && can_vec_set_var_idx_p (outermode))
+ 	{
+ 	  location_t loc = gimple_location (stmt);
+--- a/src/gcc/gimple-iterator.cc
++++ b/src/gcc/gimple-iterator.cc
+@@ -32,6 +32,7 @@ along with GCC; see the file COPYING3.  If not see
+ #include "tree-cfg.h"
+ #include "tree-ssa.h"
+ #include "value-prof.h"
++#include "gimplify.h"
+ 
+ 
+ /* Mark the statement STMT as modified, and update it.  */
+@@ -943,3 +944,150 @@ gsi_start_phis (basic_block bb)
+ 
+   return i;
+ }
++
++/* Helper function for gsi_safe_insert_before and gsi_safe_insert_seq_before.
++   Find edge to insert statements before returns_twice call at the start of BB,
++   if there isn't just one, split the bb and adjust PHIs to ensure that.  */
++
++static edge
++edge_before_returns_twice_call (basic_block bb)
++{
++  gimple_stmt_iterator gsi = gsi_start_nondebug_bb (bb);
++  gcc_checking_assert (is_gimple_call (gsi_stmt (gsi))
++		       && (gimple_call_flags (gsi_stmt (gsi))
++			   & ECF_RETURNS_TWICE) != 0);
++  edge_iterator ei;
++  edge e, ad_edge = NULL, other_edge = NULL;
++  bool split = false;
++  FOR_EACH_EDGE (e, ei, bb->preds)
++    {
++      if ((e->flags & (EDGE_ABNORMAL | EDGE_EH)) == EDGE_ABNORMAL)
++	{
++	  gimple_stmt_iterator gsi
++	    = gsi_start_nondebug_after_labels_bb (e->src);
++	  gimple *ad = gsi_stmt (gsi);
++	  if (ad && gimple_call_internal_p (ad, IFN_ABNORMAL_DISPATCHER))
++	    {
++	      gcc_checking_assert (ad_edge == NULL);
++	      ad_edge = e;
++	      continue;
++	    }
++	}
++      if (other_edge || e->flags & (EDGE_ABNORMAL | EDGE_EH))
++	split = true;
++      other_edge = e;
++    }
++  gcc_checking_assert (ad_edge);
++  if (other_edge == NULL)
++    split = true;
++  if (split)
++    {
++      other_edge = split_block_after_labels (bb);
++      e = make_edge (ad_edge->src, other_edge->dest, EDGE_ABNORMAL);
++      for (gphi_iterator gsi = gsi_start_phis (other_edge->src);
++	   !gsi_end_p (gsi); gsi_next (&gsi))
++	{
++	  gphi *phi = gsi.phi ();
++	  tree lhs = gimple_phi_result (phi);
++	  tree new_lhs = copy_ssa_name (lhs);
++	  gimple_phi_set_result (phi, new_lhs);
++	  gphi *new_phi = create_phi_node (lhs, other_edge->dest);
++	  add_phi_arg (new_phi, new_lhs, other_edge, UNKNOWN_LOCATION);
++	  add_phi_arg (new_phi, PHI_ARG_DEF_FROM_EDGE (phi, ad_edge),
++		       e, gimple_phi_arg_location_from_edge (phi, ad_edge));
++	}
++      e->flags = ad_edge->flags;
++      e->probability = ad_edge->probability;
++      remove_edge (ad_edge);
++      if (dom_info_available_p (CDI_DOMINATORS))
++	{
++	  set_immediate_dominator (CDI_DOMINATORS, other_edge->src,
++				   recompute_dominator (CDI_DOMINATORS,
++							other_edge->src));
++	  set_immediate_dominator (CDI_DOMINATORS, other_edge->dest,
++				   recompute_dominator (CDI_DOMINATORS,
++							other_edge->dest));
++	}
++    }
++  return other_edge;
++}
++
++/* Helper function for gsi_safe_insert_before and gsi_safe_insert_seq_before.
++   Replace SSA_NAME uses in G if they are PHI results of PHIs on E->dest
++   bb with the corresponding PHI argument from E edge.  */
++
++static void
++adjust_before_returns_twice_call (edge e, gimple *g)
++{
++  use_operand_p use_p;
++  ssa_op_iter iter;
++  bool m = false;
++  FOR_EACH_SSA_USE_OPERAND (use_p, g, iter, SSA_OP_USE)
++    {
++      tree s = USE_FROM_PTR (use_p);
++      if (SSA_NAME_DEF_STMT (s)
++	  && gimple_code (SSA_NAME_DEF_STMT (s)) == GIMPLE_PHI
++	  && gimple_bb (SSA_NAME_DEF_STMT (s)) == e->dest)
++	{
++	  tree r = PHI_ARG_DEF_FROM_EDGE (SSA_NAME_DEF_STMT (s), e);
++	  SET_USE (use_p, unshare_expr (r));
++	  m = true;
++	}
++    }
++  if (m)
++    update_stmt (g);
++}
++
++/* Insert G stmt before ITER and keep ITER pointing to the same statement
++   as before.  If ITER is a returns_twice call, insert it on an appropriate
++   edge instead.  */
++
++void
++gsi_safe_insert_before (gimple_stmt_iterator *iter, gimple *g)
++{
++  gimple *stmt = gsi_stmt (*iter);
++  if (stmt
++      && is_gimple_call (stmt)
++      && (gimple_call_flags (stmt) & ECF_RETURNS_TWICE) != 0)
++    {
++      edge e = edge_before_returns_twice_call (gsi_bb (*iter));
++      basic_block new_bb = gsi_insert_on_edge_immediate (e, g);
++      if (new_bb)
++	e = single_succ_edge (new_bb);
++      adjust_before_returns_twice_call (e, g);
++      *iter = gsi_for_stmt (stmt);
++    }
++  else
++    gsi_insert_before (iter, g, GSI_SAME_STMT);
++}
++
++/* Similarly for sequence SEQ.  */
++
++void
++gsi_safe_insert_seq_before (gimple_stmt_iterator *iter, gimple_seq seq)
++{
++  if (gimple_seq_empty_p (seq))
++    return;
++  gimple *stmt = gsi_stmt (*iter);
++  if (stmt
++      && is_gimple_call (stmt)
++      && (gimple_call_flags (stmt) & ECF_RETURNS_TWICE) != 0)
++    {
++      edge e = edge_before_returns_twice_call (gsi_bb (*iter));
++      gimple *f = gimple_seq_first_stmt (seq);
++      gimple *l = gimple_seq_last_stmt (seq);
++      basic_block new_bb = gsi_insert_seq_on_edge_immediate (e, seq);
++      if (new_bb)
++	e = single_succ_edge (new_bb);
++      for (gimple_stmt_iterator gsi = gsi_for_stmt (f); ; gsi_next (&gsi))
++	{
++	  gimple *g = gsi_stmt (gsi);
++	  adjust_before_returns_twice_call (e, g);
++	  if (g == l)
++	    break;
++	}
++      *iter = gsi_for_stmt (stmt);
++    }
++  else
++    gsi_insert_seq_before (iter, seq, GSI_SAME_STMT);
++}
+--- a/src/gcc/gimple-iterator.h
++++ b/src/gcc/gimple-iterator.h
+@@ -88,6 +88,8 @@ extern void gsi_insert_on_edge (edge, gimple *);
+ extern void gsi_insert_seq_on_edge (edge, gimple_seq);
+ extern basic_block gsi_insert_on_edge_immediate (edge, gimple *);
+ extern basic_block gsi_insert_seq_on_edge_immediate (edge, gimple_seq);
++extern void gsi_safe_insert_before (gimple_stmt_iterator *, gimple *);
++extern void gsi_safe_insert_seq_before (gimple_stmt_iterator *, gimple_seq);
+ extern void gsi_commit_edge_inserts (void);
+ extern void gsi_commit_one_edge_insert (edge, basic_block *);
+ extern gphi_iterator gsi_start_phis (basic_block);
 --- a/src/gcc/gimple-low.cc
 +++ b/src/gcc/gimple-low.cc
 @@ -374,15 +374,22 @@ assumption_copy_decl (tree decl, copy_body_data *id)
@@ -16750,6 +17790,85 @@ LANG=C git diff --no-renames --src-prefi
                break;
  
  	    gcond *cond_stmt = as_a <gcond *> (stmt);
+--- a/src/gcc/ipa-icf.cc
++++ b/src/gcc/ipa-icf.cc
+@@ -3389,6 +3389,7 @@ sem_item_optimizer::merge_classes (unsigned int prev_class_count,
+ 	  continue;
+ 
+ 	sem_item *source = c->members[0];
++	bool this_merged_p = false;
+ 
+ 	if (DECL_NAME (source->decl)
+ 	    && MAIN_NAME_P (DECL_NAME (source->decl)))
+@@ -3435,7 +3436,7 @@ sem_item_optimizer::merge_classes (unsigned int prev_class_count,
+ 	    if (dbg_cnt (merged_ipa_icf))
+ 	      {
+ 		bool merged = source->merge (alias);
+-		merged_p |= merged;
++		this_merged_p |= merged;
+ 
+ 		if (merged && alias->type == VAR)
+ 		  {
+@@ -3444,6 +3445,35 @@ sem_item_optimizer::merge_classes (unsigned int prev_class_count,
+ 		  }
+ 	      }
+ 	  }
++
++	merged_p |= this_merged_p;
++	if (this_merged_p
++	    && source->type == FUNC
++	    && (!flag_wpa || flag_checking))
++	  {
++	    unsigned i;
++	    tree name;
++	    FOR_EACH_SSA_NAME (i, name, DECL_STRUCT_FUNCTION (source->decl))
++	      {
++		/* We need to either merge or reset SSA_NAME_*_INFO.
++		   For merging we don't preserve the mapping between
++		   original and alias SSA_NAMEs from successful equals
++		   calls.  */
++		if (POINTER_TYPE_P (TREE_TYPE (name)))
++		  {
++		    if (SSA_NAME_PTR_INFO (name))
++		      {
++			gcc_checking_assert (!flag_wpa);
++			SSA_NAME_PTR_INFO (name) = NULL;
++		      }
++		  }
++		else if (SSA_NAME_RANGE_INFO (name))
++		  {
++		    gcc_checking_assert (!flag_wpa);
++		    SSA_NAME_RANGE_INFO (name) = NULL;
++		  }
++	      }
++	  }
+       }
+ 
+   if (!m_merged_variables.is_empty ())
+--- a/src/gcc/lower-subreg.cc
++++ b/src/gcc/lower-subreg.cc
+@@ -926,6 +926,21 @@ resolve_simple_move (rtx set, rtx_insn *insn)
+ 	     SRC's operator.  */
+ 	  dest = resolve_operand_for_swap_move_operator (dest);
+ 	  src = src_op;
++	  if (resolve_reg_p (src))
++	    {
++	      gcc_assert (GET_CODE (src) == CONCATN);
++	      if (reg_overlap_mentioned_p (XVECEXP (dest, 0, 0),
++					   XVECEXP (src, 0, 1)))
++		{
++		  /* If there is overlap between the first half of the
++		     destination and what will be stored to the second one,
++		     use a temporary pseudo.  See PR114211.  */
++		  rtx tem = gen_reg_rtx (GET_MODE (XVECEXP (src, 0, 1)));
++		  emit_move_insn (tem, XVECEXP (src, 0, 1));
++		  src = copy_rtx (src);
++		  XVECEXP (src, 0, 1) = tem;
++		}
++	    }
+ 	}
+       else if (resolve_reg_p (src_op))
+ 	{
 --- a/src/gcc/lra-constraints.cc
 +++ b/src/gcc/lra-constraints.cc
 @@ -5271,6 +5271,11 @@ lra_constraints (bool first_p)
@@ -38388,7 +39507,47 @@ new file mode 100644
  
  /* ((x & 0x1) == 0) ? y : z <op> y -> (-(typeof(y))(x & 0x1) & z) <op> y */
  (for op (bit_xor bit_ior)
-@@ -4546,6 +4553,10 @@ DEFINE_INT_AND_FLOAT_ROUND_FN (RINT)
+@@ -4455,15 +4462,36 @@ DEFINE_INT_AND_FLOAT_ROUND_FN (RINT)
+ /* (c ? a : b) op (c ? d : e)  -->  c ? (a op d) : (b op e) */
+  (simplify
+   (op (vec_cond:s @0 @1 @2) (vec_cond:s @0 @3 @4))
+-  (vec_cond @0 (op! @1 @3) (op! @2 @4)))
++  (if (TREE_CODE_CLASS (op) != tcc_comparison
++       || types_match (type, TREE_TYPE (@1))
++       || expand_vec_cond_expr_p (type, TREE_TYPE (@0), ERROR_MARK)
++       || (optimize_vectors_before_lowering_p ()
++	   /* The following is optimistic on the side of non-support, we are
++	      missing the legacy vcond{,u,eq} cases.  Do this only when
++	      lowering will be able to fixup..  */
++	   && !expand_vec_cond_expr_p (TREE_TYPE (@1),
++				       TREE_TYPE (@0), ERROR_MARK)))
++   (vec_cond @0 (op! @1 @3) (op! @2 @4))))
+ 
+ /* (c ? a : b) op d  -->  c ? (a op d) : (b op d) */
+  (simplify
+   (op (vec_cond:s @0 @1 @2) @3)
+-  (vec_cond @0 (op! @1 @3) (op! @2 @3)))
++  (if (TREE_CODE_CLASS (op) != tcc_comparison
++       || types_match (type, TREE_TYPE (@1))
++       || expand_vec_cond_expr_p (type, TREE_TYPE (@0), ERROR_MARK)
++       || (optimize_vectors_before_lowering_p ()
++	   && !expand_vec_cond_expr_p (TREE_TYPE (@1),
++				       TREE_TYPE (@0), ERROR_MARK)))
++   (vec_cond @0 (op! @1 @3) (op! @2 @3))))
+  (simplify
+   (op @3 (vec_cond:s @0 @1 @2))
+-  (vec_cond @0 (op! @3 @1) (op! @3 @2))))
++  (if (TREE_CODE_CLASS (op) != tcc_comparison
++       || types_match (type, TREE_TYPE (@1))
++       || expand_vec_cond_expr_p (type, TREE_TYPE (@0), ERROR_MARK)
++       || (optimize_vectors_before_lowering_p ()
++	   && !expand_vec_cond_expr_p (TREE_TYPE (@1),
++				       TREE_TYPE (@0), ERROR_MARK)))
++   (vec_cond @0 (op! @3 @1) (op! @3 @2)))))
+ 
+ #if GIMPLE
+ (match (nop_atomic_bit_test_and_p @0 @1 @4)
+@@ -4546,6 +4574,10 @@ DEFINE_INT_AND_FLOAT_ROUND_FN (RINT)
  /* (v ? w : 0) ? a : b is just (v & w) ? a : b
     Currently disabled after pass lvec because ARM understands
     VEC_COND_EXPR<v==w,-1,0> but not a plain v==w fed to BIT_IOR_EXPR.  */
@@ -38399,7 +39558,7 @@ new file mode 100644
  (simplify
   (vec_cond (vec_cond:s @0 @3 integer_zerop) @1 @2)
   (if (optimize_vectors_before_lowering_p () && types_match (@0, @3))
-@@ -4580,6 +4591,7 @@ DEFINE_INT_AND_FLOAT_ROUND_FN (RINT)
+@@ -4580,6 +4612,7 @@ DEFINE_INT_AND_FLOAT_ROUND_FN (RINT)
   (vec_cond @0 @3 (vec_cond:s @1 @2 @3))
   (if (optimize_vectors_before_lowering_p () && types_match (@0, @1))
    (vec_cond (bit_and (bit_not @0) @1) @2 @3)))
@@ -38407,7 +39566,7 @@ new file mode 100644
  
  /* Canonicalize mask ? { 0, ... } : { -1, ...} to ~mask if the mask
     types are compatible.  */
-@@ -5780,19 +5792,19 @@ DEFINE_INT_AND_FLOAT_ROUND_FN (RINT)
+@@ -5780,19 +5813,19 @@ DEFINE_INT_AND_FLOAT_ROUND_FN (RINT)
  		   >= TYPE_PRECISION (TREE_TYPE (@10)))
  		  && (TYPE_UNSIGNED (TREE_TYPE (@00))
  		      == TYPE_UNSIGNED (TREE_TYPE (@10))))
@@ -38433,7 +39592,7 @@ new file mode 100644
  	}
  	(if (above || below)
  	 (if (cmp == EQ_EXPR || cmp == NE_EXPR)
-@@ -8292,7 +8304,14 @@ and,
+@@ -8292,7 +8325,14 @@ and,
  
  (simplify
   (vec_perm vec_same_elem_p@0 @0 @1)
@@ -415792,7 +416951,233 @@ new file mode 100644
        if ((GET_CODE (op) == FLOAT || GET_CODE (op) == UNSIGNED_FLOAT)
 --- a/src/gcc/testsuite/ChangeLog
 +++ b/src/gcc/testsuite/ChangeLog
-@@ -1,3 +1,1929 @@
+@@ -1,3 +1,2155 @@
++2024-03-22  liuhongt  <hongtao.liu@intel.com>
++
++	Backported from master:
++	2024-03-22  liuhongt  <hongtao.liu@intel.com>
++
++	PR tree-optimization/114396
++	* gcc.target/i386/pr114396.c: Move to...
++	* gcc.c-torture/execute/pr114396.c: ...here.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/114231
++	* gcc.dg/vect/pr114231.c: New testcase.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2023-12-14  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/112793
++	* g++.dg/vect/pr112793.cc: New testcase.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-01-31  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/113670
++	* gcc.target/i386/pr113670.c: New testcase.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-01-29  Richard Biener  <rguenther@suse.de>
++
++	PR middle-end/113622
++	* gcc.target/i386/pr113622-1.c: New testcase.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-03-04  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/114203
++	* gcc.dg/torture/pr114203.c: New testcase.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-02-26  Richard Biener  <rguenther@suse.de>
++
++	PR middle-end/114070
++	* gcc.dg/torture/pr114070.c: New testcase.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-02-22  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/114027
++	* gcc.dg/vect/pr114027.c: New testcase.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-01-23  Richard Biener  <rguenther@suse.de>
++
++	PR debug/112718
++	* gcc.dg/debug/pr112718.c: New testcase.
++
++2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	Backported from master:
++	2024-03-21  Richard Biener  <rguenther@suse.de>
++
++	PR tree-optimization/111736
++	* gcc.target/i386/pr111736.c: New testcase.
++
++2024-03-21  liuhongt  <hongtao.liu@intel.com>
++
++	Backported from master:
++	2024-03-21  liuhongt  <hongtao.liu@intel.com>
++
++	* gcc.target/i386/pr114396.c: New test.
++
++2024-03-21  Jeevitha  <jeevitha@linux.ibm.com>
++
++	Backported from master:
++	2024-03-07  Jeevitha Palanisamy  <jeevitha@linux.ibm.com>
++
++	PR target/113950
++	* gcc.target/powerpc/pr113950.c: New testcase.
++
++2024-03-19  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2024-03-13  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/114001
++	* gfortran.dg/is_contiguous_4.f90: New test.
++
++2024-03-19  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2024-03-18  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/103715
++	* gfortran.dg/pr103715.f90: New test.
++
++2024-03-19  Uros Bizjak  <ubizjak@gmail.com>
++
++	PR target/111822
++	* g++.target/i386/pr111822.C (dg-do): Compile only for ia32 targets.
++	(dg-options): Add -march=x86-64.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-13  Jakub Jelinek  <jakub@redhat.com>
++
++	PR sanitizer/112709
++	* gcc.dg/asan/pr112709-2.c: New test.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-13  Jakub Jelinek  <jakub@redhat.com>
++
++	PR sanitizer/112709
++	* gcc.dg/ubsan/pr112709-1.c: New test.
++	* gcc.dg/ubsan/pr112709-2.c: New test.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	PR target/114339
++	* gcc.target/i386/pr114339.c: New test.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-14  Jakub Jelinek  <jakub@redhat.com>
++
++	PR middle-end/113907
++	* gcc.dg/pr113907-1.c: New test.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-14  Jakub Jelinek  <jakub@redhat.com>
++
++	PR target/114310
++	* gcc.dg/pr114310.c: New test.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-07  Jakub Jelinek  <jakub@redhat.com>
++
++	PR rtl-optimization/110079
++	* gcc.dg/pr110079.c: New test.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-05  Jakub Jelinek  <jakub@redhat.com>
++
++	PR rtl-optimization/114211
++	* gcc.dg/pr114211.c: New test.
++
++2024-03-15  Jakub Jelinek  <jakub@redhat.com>
++
++	Backported from master:
++	2024-03-04  Jakub Jelinek  <jakub@redhat.com>
++
++	PR target/114184
++	* gcc.target/i386/pr114184.c: New test.
++
++2024-03-15  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2024-03-12  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/110826
++	* gfortran.dg/proc_ptr_comp_53.f90: New test.
++
++2024-03-15  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2023-12-05  Harald Anlauf  <anlauf@gmx.de>
++		    Tobias Burnus   <tobias@codesourcery.com>
++
++	PR fortran/100988
++	* gfortran.dg/coarray_poly_6.f90: Adjust pattern.
++	* gfortran.dg/coarray_poly_7.f90: Likewise.
++	* gfortran.dg/coarray_poly_8.f90: Likewise.
++	* gfortran.dg/missing_optional_dummy_6a.f90: Likewise.
++	* gfortran.dg/pr100988.f90: New test.
++
++2024-03-15  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2024-03-01  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/104819
++	* gfortran.dg/assumed_rank_9.f90: Adjust testcase use of NULL().
++	* gfortran.dg/pr101329.f90: Adjust testcase to conform to interp.
++	* gfortran.dg/null_actual_4.f90: New test.
++
++2024-03-15  Harald Anlauf  <anlauf@gmx.de>
++
++	Backported from master:
++	2023-11-23  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/104819
++	* gfortran.dg/assumed_rank_10.f90: Add MOLD argument to NULL().
++	* gfortran.dg/assumed_rank_8.f90: Likewise.
++
++2024-03-15  Torbjörn SVENSSON  <torbjorn.svensson@foss.st.com>
++
++	PR testsuite/114343
++	* gcc.dg/analyzer/null-deref-pr108251-smp_fetch_ssl_fc_has_early-O2.c:
++	Added missing } in the dg-bogus comment.
++
 +2024-03-14  liuhongt  <hongtao.liu@intel.com>
 +
 +	Backported from master:
@@ -419369,6 +420754,42 @@ new file mode 100644
 +}
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/g++.dg/vect/pr112793.cc
+@@ -0,0 +1,32 @@
++// { dg-do compile }
++// { dg-require-effective-target c++11 }
++// { dg-additional-options "-march=znver2" { target x86_64-*-* i?86-*-* } }
++
++typedef double T;
++T c, s;
++T a[16];
++struct Matrix4 {
++  Matrix4(){}
++  Matrix4(T e, T f, T i, T j) {
++    r[1] = r[4] = e;
++    r[5] = f;
++    r[8] = i;
++    r[9] = j;
++  }
++  Matrix4 operator*(Matrix4 a) {
++    return Matrix4(
++       r[0] * a.r[4] + r[4] + r[15] + r[6],
++       r[1] * a.r[4] + 1 + 2 + 3,  r[0] * r[8] + 1 + 2 + 3,
++       r[1] * r[8] + r[1] + r[14] + r[2] * r[3]);
++  }
++  T r[16] = {};
++};
++Matrix4 t1, t2;
++Matrix4 tt;
++Matrix4 getRotAltAzToEquatorial()
++{
++  t2.r[4] =  0;
++  t1.r[1] =  -s;
++  t1.r[8] = 0;
++  return t1 * t2;
++}
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/g++.dg/warn/Wmismatched-new-delete-8.C
 @@ -0,0 +1,42 @@
 +/* PR tree-optimization/109804 */
@@ -419455,8 +420876,8 @@ new file mode 100644
 +++ b/src/gcc/testsuite/g++.target/i386/pr111822.C
 @@ -0,0 +1,45 @@
 +/* PR target/111822 */
-+/* { dg-do compile } */
-+/* { dg-options "-O2 -flive-range-shrinkage -fno-dce -fnon-call-exceptions" } */
++/* { dg-do compile { target ia32 } } */
++/* { dg-options "-O2 -flive-range-shrinkage -fno-dce -fnon-call-exceptions -march=x86-64" } */
 +
 +typedef union {
 +  int *pNativeClosure;
@@ -420787,6 +422208,115 @@ new file mode 100644
 +}
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.c-torture/execute/pr114396.c
+@@ -0,0 +1,105 @@
++/* PR tree-optimization/114396 */
++/* { dg-additional-options "-fwrapv -fno-vect-cost-model" } */
++
++short a = 0xF;
++short b[16];
++unsigned short ua = 0xF;
++unsigned short ub[16];
++
++short
++__attribute__((noipa))
++foo (short a)
++{
++  for (int e = 0; e < 9; e += 1)
++    b[e] = a *= 5;
++  return a;
++}
++
++short
++__attribute__((noipa))
++foo1 (short a)
++{
++  for (int e = 0; e < 9; e += 1)
++    b[e] = a *= -5;
++  return a;
++}
++
++unsigned short
++__attribute__((noipa))
++foou (unsigned short a)
++{
++  for (int e = 0; e < 9; e += 1)
++    ub[e] = a *= -5;
++  return a;
++}
++
++unsigned short
++__attribute__((noipa))
++foou1 (unsigned short a)
++{
++  for (int e = 0; e < 9; e += 1)
++    ub[e] = a *= 5;
++  return a;
++}
++
++short
++__attribute__((noipa,optimize("O3")))
++foo_o3 (short a)
++{
++  for (int e = 0; e < 9; e += 1)
++    b[e] = a *= 5;
++  return a;
++}
++
++short
++__attribute__((noipa,optimize("O3")))
++foo1_o3 (short a)
++{
++  for (int e = 0; e < 9; e += 1)
++    b[e] = a *= -5;
++  return a;
++}
++
++unsigned short
++__attribute__((noipa,optimize("O3")))
++foou_o3 (unsigned short a)
++{
++  for (int e = 0; e < 9; e += 1)
++    ub[e] = a *= -5;
++  return a;
++}
++
++unsigned short
++__attribute__((noipa,optimize("O3")))
++foou1_o3 (unsigned short a)
++{
++  for (int e = 0; e < 9; e += 1)
++    ub[e] = a *= 5;
++  return a;
++}
++
++int main() {
++  unsigned short uexp, ures;
++  short exp, res;
++  exp = foo (a);
++  res = foo_o3 (a);
++  if (exp != res)
++    __builtin_abort ();
++
++  exp = foo1 (a);
++  res = foo1_o3 (a);
++  if (exp != res)
++    __builtin_abort ();
++
++  uexp = foou (a);
++  ures = foou_o3 (a);
++  if (uexp != ures)
++    __builtin_abort ();
++
++  uexp = foou1 (a);
++  ures = foou1_o3 (a);
++  if (uexp != ures)
++    __builtin_abort ();
++
++  return 0;
++}
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.c-torture/execute/pr90348.c
 @@ -0,0 +1,38 @@
 +/* PR middle-end/90348 */
@@ -420864,12 +422394,66 @@ new file mode 100644
  static inline struct connection *__objt_conn(enum obj_type *t)
  {
 - return ((struct connection *)(((void *)(t)) - ((long)&((struct connection *)0)->obj_type)));
-+ return ((struct connection *)(((void *)(t)) - ((long)&((struct connection *)0)->obj_type))); /* { dg-bogus "may result in an unaligned pointer value" "Fixed in r14-6517-gb7e4a4c626e" { xfail short_enums } */
++ return ((struct connection *)(((void *)(t)) - ((long)&((struct connection *)0)->obj_type))); /* { dg-bogus "may result in an unaligned pointer value" "Fixed in r14-6517-gb7e4a4c626e" { xfail short_enums } } */
  }
  static inline struct connection *objt_conn(enum obj_type *t)
  {
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/asan/pr112709-2.c
+@@ -0,0 +1,50 @@
++/* PR sanitizer/112709 */
++/* { dg-do compile } */
++/* { dg-options "-fsanitize=address -O2" } */
++
++struct S { char c[1024]; } *p;
++int foo (int);
++
++__attribute__((returns_twice, noipa)) int
++bar (struct S x)
++{
++  (void) x.c[0];
++  return 0;
++}
++
++void
++baz (int *y)
++{
++  foo (1);
++  *y = bar (*p);
++}
++
++void
++qux (int x, int *y)
++{
++  if (x == 25)
++    x = foo (2);
++  else if (x == 42)
++    x = foo (foo (3));
++  *y = bar (*p);
++}
++
++void
++corge (int x, int *y)
++{
++  void *q[] = { &&l1, &&l2, &&l3, &&l3 };
++  if (x == 25)
++    {
++    l1:
++      x = foo (2);
++    }
++  else if (x == 42)
++    {
++    l2:
++      x = foo (foo (3));
++    }
++l3:
++  *y = bar (*p);
++  if (x < 4)
++    goto *q[x & 3];
++}
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.dg/attr-assume-6.c
 @@ -0,0 +1,14 @@
 +/* PR middle-end/110754 */
@@ -421147,6 +422731,22 @@ new file mode 100644
 +/* { dg-final { scan-assembler-not "DW_TAG_structure_type" } } */
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/debug/pr112718.c
+@@ -0,0 +1,12 @@
++/* { dg-do compile } */
++/* { dg-require-effective-target lto } */
++/* { dg-options "-g -fdebug-types-section -flto -ffat-lto-objects" } */
++
++struct {
++  int h;
++  unsigned char data[20 + 24 * 6];
++} _EC_X9_62_PRIME_192V2;
++struct {
++  int h;
++  unsigned char data[20 + 24 * 6];
++} _EC_X9_62_PRIME_192V3;
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.dg/float_opposite_arm-1.c
 @@ -0,0 +1,17 @@
 +/* { dg-do compile } */
@@ -421243,6 +422843,53 @@ new file mode 100644
 +}
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/pr110079.c
+@@ -0,0 +1,43 @@
++/* PR rtl-optimization/110079 */
++/* { dg-do compile { target lra } } */
++/* { dg-options "-O2" } */
++/* { dg-additional-options "-freorder-blocks-and-partition" { target freorder } } */
++
++int a;
++__attribute__((cold)) int bar (char *);
++__attribute__((hot)) int baz (char *);
++
++void
++foo (void)
++{
++l1:
++  while (a)
++    ;
++  bar ("");
++  asm goto ("" : : : : l2);
++  asm ("");
++l2:
++  goto l1;
++}
++
++void
++qux (void)
++{
++  asm goto ("" : : : : l1);
++  bar ("");
++  goto l1;
++l1:
++  baz ("");
++}
++
++void
++corge (void)
++{
++  asm goto ("" : : : : l1);
++  baz ("");
++l2:
++  return;
++l1:
++  bar ("");
++  goto l2;
++}
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.dg/pr110755.c
 @@ -0,0 +1,29 @@
 +/* PR tree-optimization/110755 */
@@ -421480,6 +423127,59 @@ new file mode 100644
 +
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/pr113907-1.c
+@@ -0,0 +1,49 @@
++/* PR middle-end/113907 */
++/* { dg-do run } */
++/* { dg-options "-O2" } */
++/* { dg-additional-options "-minline-all-stringops" { target i?86-*-* x86_64-*-* } } */
++
++static inline int
++foo (int len, void *indata, void *outdata)
++{
++  if (len < 0 || (len & 7) != 0)
++    return 0;
++  if (len != 0 && indata != outdata)
++    __builtin_memcpy (outdata, indata, len);
++  return len;
++}
++
++static inline int
++bar (int len, void *indata, void *outdata)
++{
++  if (len < 0 || (len & 1) != 0)
++    return 0;
++  if (len != 0 && indata != outdata)
++    __builtin_memcpy (outdata, indata, len);
++  return len;
++}
++
++int (*volatile p1) (int, void *, void *) = foo;
++int (*volatile p2) (int, void *, void *) = bar;
++
++__attribute__((noipa)) int
++baz (int len, void *indata, void *outdata)
++{
++  if ((len & 6) != 0)
++    bar (len, indata, outdata);
++  else
++    foo (len, indata, outdata);
++}
++
++struct S { char buf[64]; } s __attribute__((aligned (8)));
++
++int
++main ()
++{
++  for (int i = 0; i < 64; ++i)
++    s.buf[i] = ' ' + i;
++  p2 (2, s.buf, s.buf + 33);
++  for (int i = 0; i < 64; ++i)
++    if (s.buf[i] != ' ' + ((i >= 33 && i < 35) ? i - 33 : i))
++      __builtin_abort ();
++}
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.dg/pr114090.c
 @@ -0,0 +1,38 @@
 +/* PR tree-optimization/114090 */
@@ -421520,6 +423220,57 @@ new file mode 100644
 +  if (baz (v) != v)
 +    __builtin_abort ();
 +}
+new file mode 100644
+--- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/pr114211.c
+@@ -0,0 +1,23 @@
++/* PR rtl-optimization/114211 */
++/* { dg-do run { target int128 } } */
++/* { dg-options "-O -fno-tree-coalesce-vars -Wno-psabi" } */
++
++typedef unsigned __int128 V __attribute__((__vector_size__ (16)));
++unsigned int u;
++V v;
++
++V
++foo (unsigned __int128 h)
++{
++  h = h << 64 | h >> 64;
++  h *= ~u;
++  return h + v;
++}
++
++int
++main ()
++{
++  V x = foo (1);
++  if (x[0] != (unsigned __int128) 0xffffffff << 64)
++    __builtin_abort ();
++}
+new file mode 100644
+--- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/pr114310.c
+@@ -0,0 +1,20 @@
++/* PR target/114310 */
++/* { dg-do run { target int128 } } */
++
++volatile __attribute__((aligned (sizeof (__int128_t)))) __int128_t v = 10;
++
++int
++main ()
++{
++#if __GCC_HAVE_SYNC_COMPARE_AND_SWAP_16
++  if (__sync_val_compare_and_swap (&v, (__int128_t) 10, (__int128_t) 0) != 10)
++    __builtin_abort ();
++  if (__sync_val_compare_and_swap (&v, (__int128_t) 10, (__int128_t) 15) != 0)
++    __builtin_abort ();
++  if (__sync_val_compare_and_swap (&v, (__int128_t) 0, (__int128_t) 42) != 0)
++    __builtin_abort ();
++  if (__sync_val_compare_and_swap (&v, (__int128_t) 31, (__int128_t) 35) != 42)
++    __builtin_abort ();
++#endif
++  return 0;
++}
 --- a/src/gcc/testsuite/gcc.dg/pr56837.c
 +++ b/src/gcc/testsuite/gcc.dg/pr56837.c
 @@ -62,5 +62,5 @@ fv (void)
@@ -421980,6 +423731,47 @@ new file mode 100644
 +int main() { d(); }
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/torture/pr114070.c
+@@ -0,0 +1,12 @@
++/* { dg-do compile } */
++/* { dg-additional-options "-fno-vect-cost-model" } */
++
++int unresolved(unsigned dirmask, unsigned mask, int *unresolved_n)
++{
++  for (int i = 0; i < 1024; i++) {
++    mask |= 1;
++    if (!unresolved_n[i] || unresolved_n[i] & 70000)
++      dirmask |= 1;
++  }
++  return (dirmask == mask);
++}
+new file mode 100644
+--- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/torture/pr114203.c
+@@ -0,0 +1,21 @@
++/* { dg-do run } */
++
++int __attribute__((noipa))
++foo (unsigned char b)
++{
++  int c = 0;
++
++  while (b) {
++      b >>= 1;
++      c++;
++  }
++
++  return c;
++}
++
++int main()
++{
++  if (foo(0) != 0)
++    __builtin_abort ();
++  return 0;
++}
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.dg/tree-ssa/pr111583-1.c
 @@ -0,0 +1,30 @@
 +/* { dg-do run } */
@@ -422334,6 +424126,140 @@ new file mode 100644
 +#endif
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/ubsan/pr112709-1.c
+@@ -0,0 +1,64 @@
++/* PR sanitizer/112709 */
++/* { dg-do compile } */
++/* { dg-options "-fsanitize=undefined -O2" } */
++
++struct S { char c[1024]; };
++int foo (int);
++
++__attribute__((returns_twice, noipa)) struct S
++bar (int x)
++{
++  (void) x;
++  struct S s = {};
++  s.c[42] = 42;
++  return s;
++}
++
++void
++baz (struct S *p)
++{
++  foo (1);
++  *p = bar (0);
++}
++
++void
++qux (int x, struct S *p)
++{
++  if (x == 25)
++    x = foo (2);
++  else if (x == 42)
++    x = foo (foo (3));
++  *p = bar (x);
++}
++
++void
++corge (int x, struct S *p)
++{
++  void *q[] = { &&l1, &&l2, &&l3, &&l3 };
++  if (x == 25)
++    {
++    l1:
++      x = foo (2);
++    }
++  else if (x == 42)
++    {
++    l2:
++      x = foo (foo (3));
++    }
++l3:
++  *p = bar (x);
++  if (x < 4)
++    goto *q[x & 3];
++}
++
++void
++freddy (int x, struct S *p)
++{
++  *p = bar (x);
++  ++p;
++  if (x == 25)
++    x = foo (2);
++  else if (x == 42)
++    x = foo (foo (3));
++  *p = bar (x);
++}
+new file mode 100644
+--- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/ubsan/pr112709-2.c
+@@ -0,0 +1,62 @@
++/* PR sanitizer/112709 */
++/* { dg-do compile } */
++/* { dg-options "-fsanitize=undefined -O2" } */
++
++struct S { char c[1024]; } *p;
++int foo (int);
++
++__attribute__((returns_twice, noipa)) int
++bar (struct S x)
++{
++  (void) x.c[0];
++  return 0;
++}
++
++void
++baz (int *y)
++{
++  foo (1);
++  *y = bar (*p);
++}
++
++void
++qux (int x, int *y)
++{
++  if (x == 25)
++    x = foo (2);
++  else if (x == 42)
++    x = foo (foo (3));
++  *y = bar (*p);
++}
++
++void
++corge (int x, int *y)
++{
++  void *q[] = { &&l1, &&l2, &&l3, &&l3 };
++  if (x == 25)
++    {
++    l1:
++      x = foo (2);
++    }
++  else if (x == 42)
++    {
++    l2:
++      x = foo (foo (3));
++    }
++l3:
++  *y = bar (*p);
++  if (x < 4)
++    goto *q[x & 3];
++}
++
++void
++freddy (int x, int *y, struct S *p)
++{
++  bar (*p);
++  ++p;
++  if (x == 25)
++    x = foo (2);
++  else if (x == 42)
++    x = foo (foo (3));
++  *y = bar (*p);
++}
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.dg/ubsan/pr113012.c
 @@ -0,0 +1,17 @@
 +/* { dg-do compile } */
@@ -422539,6 +424465,52 @@ new file mode 100644
 +  for(int i = 0; i < 4; i ++)
 +    w9 *= v.b ? v.a-- < 0 : 0;
 +}
+new file mode 100644
+--- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/vect/pr114027.c
+@@ -0,0 +1,26 @@
++#include "tree-vect.h"
++
++int __attribute__((noipa))
++foo (int *f, int n)
++{
++  int res = 0;
++  for (int i = 0; i < n; ++i)
++    {
++      if (f[2*i])
++        res = 2;
++      if (f[2*i+1])
++        res = -2;
++    }
++  return res;
++}
++
++int f[] = { 1, 1, 1, 1, 1, 1, 1, 1,
++            1, 1, 1, 1, 1, 1, 1, 0 };
++
++int
++main ()
++{
++  if (foo (f, 16) != 2)
++    __builtin_abort ();
++  return 0;
++}
+new file mode 100644
+--- /dev/null
++++ b/src/gcc/testsuite/gcc.dg/vect/pr114231.c
+@@ -0,0 +1,12 @@
++/* { dg-do compile } */
++
++void f(long*);
++int ff[2];
++void f2(long, long, unsigned long);
++void k(unsigned long x, unsigned long y)
++{
++  long t = x >> ff[0];
++  long t1 = ff[1];
++  unsigned long t2 = y >> ff[0];
++  f2(t1, t+t2, t2);
++}
 --- a/src/gcc/testsuite/gcc.dg/vect/tsvc/tsvc.h
 +++ b/src/gcc/testsuite/gcc.dg/vect/tsvc/tsvc.h
 @@ -11,9 +11,12 @@
@@ -423955,6 +425927,33 @@ new file mode 100644
 +}
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.target/i386/pr111736.c
+@@ -0,0 +1,23 @@
++/* { dg-do compile } */
++/* { dg-options "-O2 -fsanitize=address" } */
++
++int __seg_gs m;
++
++int foo (void)
++{
++  return m;
++}
++
++extern int  __seg_gs n;
++
++int bar (void)
++{
++  return n;
++}
++
++int baz (int __seg_gs *o)
++{
++  return *o;
++}
++
++/* { dg-final { scan-assembler-not "asan_report_load" } } */
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.target/i386/pr111820-1.c
 @@ -0,0 +1,16 @@
 +/* { dg-do compile } */
@@ -424192,6 +426191,22 @@ new file mode 100644
 +}
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.target/i386/pr113622-1.c
+@@ -0,0 +1,12 @@
++/* { dg-do compile } */
++/* { dg-options "-O2 -mavx512f -w" } */
++
++typedef float __attribute__ ((vector_size (64))) vec;
++register vec a asm("zmm5"), b asm("zmm6"), c asm("zmm7");
++
++void
++test (void)
++{
++  for (int i = 0; i < 8; i++)
++    c[i] = a[i] < b[i] ? 0.1 : 0.2;
++}
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.target/i386/pr113656.c
 @@ -0,0 +1,12 @@
 +/* PR rtl-optimization/113656 */
@@ -424208,6 +426223,26 @@ new file mode 100644
 +}
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.target/i386/pr113670.c
+@@ -0,0 +1,16 @@
++/* { dg-do compile } */
++/* { dg-options "-msse2 -O2 -fno-vect-cost-model" } */
++
++typedef float __attribute__ ((vector_size (16))) vec;
++typedef int __attribute__ ((vector_size (16))) ivec;
++ivec x;
++
++void
++test (void)
++{
++  register vec a asm("xmm3"), b asm("xmm4");
++  register ivec c asm("xmm5");
++  for (int i = 0; i < 4; i++)
++    c[i] = a[i] < b[i] ? -1 : 1;
++  x = c;
++}
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.target/i386/pr113921.c
 @@ -0,0 +1,20 @@
 +/* PR middle-end/113921 */
@@ -424230,6 +426265,56 @@ new file mode 100644
 +  if (foo () != 42)
 +    __builtin_abort ();
 +}
+new file mode 100644
+--- /dev/null
++++ b/src/gcc/testsuite/gcc.target/i386/pr114184.c
+@@ -0,0 +1,22 @@
++/* PR target/114184 */
++/* { dg-do compile } */
++/* { dg-options "-Og -mavx2" } */
++
++typedef unsigned char V __attribute__((vector_size (32)));
++typedef unsigned char W __attribute__((vector_size (16)));
++
++_Complex long double
++foo (void)
++{
++  _Complex long double d;
++  *(V *)&d = (V) { 149, 136, 89, 42, 38, 240, 196, 194 };
++  return d;
++}
++
++long double
++bar (void)
++{
++  long double d;
++  *(W *)&d = (W) { 149, 136, 89, 42, 38, 240, 196, 194 };
++  return d;
++}
+new file mode 100644
+--- /dev/null
++++ b/src/gcc/testsuite/gcc.target/i386/pr114339.c
+@@ -0,0 +1,20 @@
++/* PR target/114339 */
++/* { dg-do run } */
++/* { dg-options "-O2 -Wno-psabi" } */
++/* { dg-additional-options "-mavx" { target avx_runtime } } */
++
++typedef long long V __attribute__((vector_size (16)));
++
++__attribute__((noipa)) V
++foo (V a)
++{
++  return a <= (V) {0, __LONG_LONG_MAX__ };
++}
++
++int
++main ()
++{
++  V t = foo ((V) { 0, 0 });
++  if (t[0] != -1LL || t[1] != -1LL)
++    __builtin_abort ();
++}
 --- a/src/gcc/testsuite/gcc.target/i386/pr88531-1b.c
 +++ b/src/gcc/testsuite/gcc.target/i386/pr88531-1b.c
 @@ -1,5 +1,5 @@
@@ -424561,6 +426646,34 @@ new file mode 100644
 +}
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gcc.target/powerpc/pr113950.c
+@@ -0,0 +1,24 @@
++/* PR target/113950 */
++/* { dg-require-effective-target powerpc_vsx_ok } */
++/* { dg-options "-O2 -mvsx" } */
++
++/* Verify we do not ICE on the following.  */
++
++void abort (void);
++
++int main ()
++{
++  int i;
++  vector signed long long vsll_result, vsll_expected_result;
++  signed long long sll_arg1;
++
++  sll_arg1 = 300;
++  vsll_expected_result = (vector signed long long) {300, 300};
++  vsll_result = __builtin_vsx_splat_2di (sll_arg1);  
++
++  for (i = 0; i < 2; i++)
++    if (vsll_result[i] != vsll_expected_result[i])
++      abort();
++
++  return 0;
++}
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gcc.target/powerpc/pr96762.c
 @@ -0,0 +1,13 @@
 +/* { dg-do compile } */
@@ -426219,6 +428332,90 @@ new file mode 100644
 +  end associate
 +  deallocate (z)
 +end program assoc_target
+--- a/src/gcc/testsuite/gfortran.dg/assumed_rank_10.f90
++++ b/src/gcc/testsuite/gfortran.dg/assumed_rank_10.f90
+@@ -50,9 +50,9 @@ program test
+ 
+  is_present = .false.
+ 
+- call fpa(null(), null()) ! No copy back
+- call fpi(null(), null()) ! No copy back
+- call fno(null(), null()) ! No copy back
++ call fpa(null(iip), null(jjp)) ! No copy back
++ call fpi(null(iip), null(jjp)) ! No copy back
++ call fno(null(iip), null(jjp)) ! No copy back
+ 
+  call fno() ! No copy back
+ 
+--- a/src/gcc/testsuite/gfortran.dg/assumed_rank_8.f90
++++ b/src/gcc/testsuite/gfortran.dg/assumed_rank_8.f90
+@@ -22,13 +22,13 @@ program main
+   call f (ii)
+   call f (489)
+   call f ()
+-  call f (null())
++  call f (null(kk))
+   call f (kk)
+   if (j /= 2) STOP 1
+ 
+   j = 0
+   nullify (ll)
+-  call g (null())
++  call g (null(ll))
+   call g (ll)
+   call g (ii)
+   if (j /= 1) STOP 2
+--- a/src/gcc/testsuite/gfortran.dg/assumed_rank_9.f90
++++ b/src/gcc/testsuite/gfortran.dg/assumed_rank_9.f90
+@@ -26,19 +26,20 @@ program main
+ 
+   type(t), target :: y
+   class(t), allocatable, target :: yac
+-  
++  type(t),  pointer             :: ypt
++
+   y%i = 489
+   allocate (yac)
+   yac%i = 489
+   j = 0
+   call fc()
+-  call fc(null())
++  call fc(null(yac))
+   call fc(y)
+   call fc(yac)
+   if (j /= 2) STOP 1
+ 
+   j = 0
+-  call gc(null())
++! call gc(null(yac)) ! ICE
+   call gc(y)
+   call gc(yac)
+   deallocate (yac)
+@@ -54,13 +55,14 @@ program main
+ 
+   j = 0
+   call ft()
+-  call ft(null())
++  call ft(null(yac))
+   call ft(y)
+   call ft(yac)
+   if (j /= 2) STOP 4
+ 
+   j = 0
+-  call gt(null())
++  call gt(null(ypt))
++! call gt(null(yac)) ! ICE
+   call gt(y)
+   call gt(yac)
+   deallocate (yac)
+@@ -73,6 +75,7 @@ program main
+   yac%i = 489
+   call ht(yac)
+   if (j /= 1) STOP 6
++  deallocate (yac)
+ 
+ contains
+ 
 new file mode 100644
 --- /dev/null
 +++ b/src/gcc/testsuite/gfortran.dg/assumed_type_18.f90
@@ -426361,6 +428558,36 @@ new file mode 100644
 +
 +end program alloc_comp_7
 +
+--- a/src/gcc/testsuite/gfortran.dg/coarray_poly_6.f90
++++ b/src/gcc/testsuite/gfortran.dg/coarray_poly_6.f90
+@@ -16,6 +16,6 @@ contains
+   end subroutine foo
+ end
+ ! { dg-final { scan-tree-dump-times "foo \\(struct __class_MAIN___T_0_1t & restrict x, void \\* restrict caf_token.., integer\\(kind=\[48\]\\) caf_offset..\\)" 1 "original" } }
+-! { dg-final { scan-tree-dump-times "bar \\(struct __class_MAIN___T_0_1t \\* x, void \\* restrict caf_token.., integer\\(kind=\[48\]\\) caf_offset..\\)" 1 "original" } }
++! { dg-final { scan-tree-dump-times "bar \\(struct __class_MAIN___T_0_1t \\* restrict x, void \\* restrict caf_token.., integer\\(kind=\[48\]\\) caf_offset..\\)" 1 "original" } }
+ ! { dg-final { scan-tree-dump-times "bar \\(0B, 0B, 0\\);" 1 "original" } }
+ ! { dg-final { scan-tree-dump-times "foo \\(&class.., y._data.token, \\(integer\\(kind=\[48\]\\)\\) class..._data.data - \\(integer\\(kind=\[48\]\\)\\) y._data.data\\);" 1 "original" } }
+--- a/src/gcc/testsuite/gfortran.dg/coarray_poly_7.f90
++++ b/src/gcc/testsuite/gfortran.dg/coarray_poly_7.f90
+@@ -16,6 +16,6 @@ contains
+   end subroutine foo
+ end
+ ! { dg-final { scan-tree-dump-times "foo \\(struct __class_MAIN___T_1_1t & restrict x, void \\* restrict caf_token.., integer\\(kind=\[48\]\\) caf_offset..\\)" 1 "original" } }
+-! { dg-final { scan-tree-dump-times "bar \\(struct __class_MAIN___T_1_1t \\* x, void \\* restrict caf_token.., integer\\(kind=\[48\]\\) caf_offset..\\)" 1 "original" } }
++! { dg-final { scan-tree-dump-times "bar \\(struct __class_MAIN___T_1_1t \\* restrict x, void \\* restrict caf_token.., integer\\(kind=\[48\]\\) caf_offset..\\)" 1 "original" } }
+ ! { dg-final { scan-tree-dump-times "bar \\(0B, 0B, 0\\);" 1 "original" } }
+ ! { dg-final { scan-tree-dump-times "foo \\(&class.., y._data.token, \\(integer\\(kind=\[48\]\\)\\) class..._data.data - \\(integer\\(kind=\[48\]\\)\\) y._data.data\\);" 1 "original" } }
+--- a/src/gcc/testsuite/gfortran.dg/coarray_poly_8.f90
++++ b/src/gcc/testsuite/gfortran.dg/coarray_poly_8.f90
+@@ -16,6 +16,6 @@ contains
+   end subroutine foo
+ end
+ ! { dg-final { scan-tree-dump-times "foo \\(struct __class_MAIN___T_1_1t & restrict x, void \\* restrict caf_token.., integer\\(kind=\[48\]\\) caf_offset..\\)" 1 "original" } }
+-! { dg-final { scan-tree-dump-times "bar \\(struct __class_MAIN___T_1_1t \\* x, void \\* restrict caf_token.., integer\\(kind=\[48\]\\) caf_offset..\\)" 1 "original" } }
++! { dg-final { scan-tree-dump-times "bar \\(struct __class_MAIN___T_1_1t \\* restrict x, void \\* restrict caf_token.., integer\\(kind=\[48\]\\) caf_offset..\\)" 1 "original" } }
+ ! { dg-final { scan-tree-dump-times "bar \\(0B, 0B, 0\\);" 1 "original" } }
+ ! { dg-final { scan-tree-dump-times "foo \\(&class.., y._data.token, \\(integer\\(kind=\[48\]\\)\\) class..._data.data - \\(integer\\(kind=\[48\]\\)\\) y._data.data\\);" 1 "original" } }
 new file mode 100644
 --- /dev/null
 +++ b/src/gcc/testsuite/gfortran.dg/contiguous_15.f90
@@ -426691,6 +428918,91 @@ new file mode 100644
 +end
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gfortran.dg/is_contiguous_4.f90
+@@ -0,0 +1,81 @@
++! { dg-do run }
++! PR fortran/114001 - IS_CONTIGUOUS and polymorphic dummy
++
++program main
++  implicit none
++  integer :: i, cnt = 0
++  logical :: expect
++  integer, target  :: m(10) = [(i,i=1,size(m))]
++  integer, pointer :: p(:)
++  type t
++     integer :: j
++  end type t
++  type(t),  pointer :: tt(:), tp(:)     ! Type pointer
++  class(t), pointer :: ct(:), cp(:)     ! Class pointer
++
++  p => m(1:3)
++  expect = is_contiguous (p)
++  print *, "is_contiguous (p)=", expect
++  if (.not. expect) stop 91
++  call sub_star (p, expect)
++  p => m(1::3)
++  expect = is_contiguous (p)
++  print *, "is_contiguous (p)=", expect
++  if (expect) stop 92
++  call sub_star (p, expect)
++
++  allocate (tt(10))
++  tt(:)% j = m
++  tp => tt(4:6)
++  expect = is_contiguous (tp)
++  if (.not. expect) stop 96
++  print *, "is_contiguous (tp)=", expect
++  call sub_t (tp, expect)
++  tp => tt(4::3)
++  expect = is_contiguous (tp)
++  if (expect) stop 97
++  print *, "is_contiguous (tp)=", expect
++  call sub_t (tp, expect)
++
++  allocate (ct(10))
++  ct(:)% j = m
++  cp => ct(7:9)
++  expect = is_contiguous (cp)
++  print *, "is_contiguous (cp)=", expect
++  if (.not. expect) stop 98
++  call sub_t (cp, expect)
++  cp => ct(4::3)
++  expect = is_contiguous (cp)
++  print *, "is_contiguous (cp)=", expect
++  if (expect) stop 99
++  call sub_t (cp, expect)
++
++contains
++
++  subroutine sub_star (x, expect)
++    class(*), intent(in) :: x(:)
++    logical,  intent(in) :: expect
++    cnt = cnt + 10
++    if (is_contiguous (x) .neqv. expect) then
++       print *, "sub_star(1): is_contiguous (x)=", is_contiguous (x), expect
++       stop (cnt + 1)
++    end if
++    select type (x)
++    type is (integer)
++       if (is_contiguous (x) .neqv. expect) then
++          print *, "sub_star(2): is_contiguous (x)=", is_contiguous (x), expect
++          stop (cnt + 2)
++       end if
++    end select
++  end
++
++  subroutine sub_t (x, expect)
++    class(t), intent(in) :: x(:)
++    logical,  intent(in) :: expect
++    cnt = cnt + 10
++    if (is_contiguous (x) .neqv. expect) then
++       print *, "sub_t: is_contiguous (x)=", is_contiguous (x), expect
++       stop (cnt + 3)
++    end if
++  end
++end
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gfortran.dg/ishftc_optional_size_1.f90
 @@ -0,0 +1,97 @@
 +! { dg-do run }
@@ -426790,6 +429102,17 @@ new file mode 100644
 +! print *, k4
 +! if (any (k4 /= expect4)) stop 9
 +end program p
+--- a/src/gcc/testsuite/gfortran.dg/missing_optional_dummy_6a.f90
++++ b/src/gcc/testsuite/gfortran.dg/missing_optional_dummy_6a.f90
+@@ -47,7 +47,7 @@ contains
+ 
+ end program test
+ 
+-! { dg-final { scan-tree-dump-times "scalar2 \\(slr1" 1 "original" } }
++! { dg-final { scan-tree-dump-times "scalar2 \\(.* slr1" 1 "original" } }
+ 
+ ! { dg-final { scan-tree-dump-times "= es1 != 0B" 1 "original" } }
+ ! { dg-final { scan-tree-dump-times "assumed_shape2 \\(es1" 0 "original" } }
 --- a/src/gcc/testsuite/gfortran.dg/namelist_57.f90
 +++ b/src/gcc/testsuite/gfortran.dg/namelist_57.f90
 @@ -6,7 +6,7 @@
@@ -426814,6 +429137,45 @@ new file mode 100644
  if (out(4).ne." C=  3.00000000    ,") STOP 4
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gfortran.dg/null_actual_4.f90
+@@ -0,0 +1,35 @@
++! { dg-do compile }
++! PR fortran/104819
++!
++! Reject NULL without MOLD as actual to an assumed-rank dummy.
++! See also interpretation request at
++! https://j3-fortran.org/doc/year/22/22-101r1.txt
++!
++! Test nested NULL()
++
++program p
++  implicit none
++  integer, pointer :: a, a3(:,:,:)
++  character(10), pointer :: c
++
++  call foo (a)
++  call foo (a3)
++  call foo (null (a))
++  call foo (null (a3))
++  call foo (null (null (a)))  ! Valid: nested NULL()s
++  call foo (null (null (a3))) ! Valid: nested NULL()s
++  call foo (null ())          ! { dg-error "passed to assumed-rank dummy" }
++
++  call str (null (c))
++  call str (null (null (c)))
++  call str (null ())          ! { dg-error "passed to assumed-length dummy" }
++contains
++  subroutine foo (x)
++    integer, pointer, intent(in) :: x(..)
++    print *, rank (x)
++  end
++
++  subroutine str (x)
++    character(len=*), pointer, intent(in) :: x
++  end
++end
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gfortran.dg/optional_deferred_char_1.f90
 @@ -0,0 +1,100 @@
 +! { dg-do run }
@@ -426918,6 +429280,82 @@ new file mode 100644
 +end
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gfortran.dg/pr100988.f90
+@@ -0,0 +1,61 @@
++! { dg-do compile }
++! { dg-options "-fdump-tree-original" }
++! PR fortran/100988 - RESTRICT was missing for optional arguments
++
++  ! There should be restrict qualifiers for a AND b: (4 cases)
++  subroutine plain (a, b)
++    integer  :: a, b
++    optional :: b
++  end subroutine
++
++  subroutine alloc (a, b)
++    integer     :: a, b
++    allocatable :: a, b
++    optional    :: b
++  end subroutine
++
++  subroutine upoly (a, b)
++    class(*)    :: a, b
++    optional    :: b
++  end subroutine
++
++  subroutine upoly_a (a, b)
++    class(*)    :: a, b
++    allocatable :: a, b
++    optional    :: b
++  end subroutine
++
++! { dg-final { scan-tree-dump "plain .* restrict a, .* restrict b\\)" "original" } }
++! { dg-final { scan-tree-dump "alloc .* restrict a, .* restrict b\\)" "original" } }
++! { dg-final { scan-tree-dump "upoly .* restrict a, .* restrict b\\)" "original" } }
++! { dg-final { scan-tree-dump "upoly_a .* restrict a, .* restrict b\\)" "original" } }
++
++  ! There should be no restrict qualifiers for the below 4 cases:
++  subroutine ptr (a, b)
++    integer  :: a, b
++    pointer  :: a, b
++    optional :: b
++  end subroutine
++
++  subroutine tgt (a, b)
++    integer  :: a, b
++    target   :: a, b
++    optional :: b
++  end subroutine
++
++  subroutine upoly_p (a, b)
++    class(*)    :: a, b
++    pointer     :: a, b
++    optional    :: b
++  end subroutine
++
++  subroutine upoly_t (a, b)
++    class(*)    :: a, b
++    target      :: a, b
++    optional    :: b
++  end subroutine
++
++! { dg-final { scan-tree-dump-not "ptr .* restrict " "original" } }
++! { dg-final { scan-tree-dump-not "tgt .* restrict " "original" } }
++! { dg-final { scan-tree-dump-not "upoly_p .* restrict " "original" } }
++! { dg-final { scan-tree-dump-not "upoly_t .* restrict " "original" } }
+--- a/src/gcc/testsuite/gfortran.dg/pr101329.f90
++++ b/src/gcc/testsuite/gfortran.dg/pr101329.f90
+@@ -8,6 +8,6 @@ program p
+   integer(c_int64_t), pointer :: ip8
+   print *, c_sizeof (c_null_ptr) ! valid
+   print *, c_sizeof (null ())    ! { dg-error "is not interoperable" }
+-  print *, c_sizeof (null (ip4)) ! { dg-error "is not interoperable" }
+-  print *, c_sizeof (null (ip8)) ! { dg-error "is not interoperable" }
++  print *, c_sizeof (null (ip4)) ! valid
++  print *, c_sizeof (null (ip8)) ! valid
+ end
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gfortran.dg/pr102109.f90
 @@ -0,0 +1,20 @@
 +! { dg-do compile }
@@ -427068,6 +429506,22 @@ new file mode 100644
 \ No newline at end of file
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gfortran.dg/pr103715.f90
+@@ -0,0 +1,12 @@
++! { dg-do compile }
++! PR fortran/103715 - ICE in gfc_find_gsymbol
++!
++! valgrind did report an invalid read in check_externals_procedure
++
++program p
++  select type (y => g()) ! { dg-error "Selector shall be polymorphic" }
++  end select
++  call g()
++end
++
++! { dg-prune-output "already being used as a FUNCTION" }
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gfortran.dg/pr104908.f90
 @@ -0,0 +1,32 @@
 +! { dg-do compile }
@@ -427850,6 +430304,53 @@ new file mode 100644
 +END MODULE formulaciones
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gfortran.dg/proc_ptr_comp_53.f90
+@@ -0,0 +1,43 @@
++! { dg-do compile }
++! PR fortran/110826 - procedure pointer component in DT array
++
++module m
++  implicit none
++
++  type pp
++    procedure(func_template), pointer, nopass :: f =>null()
++  end type pp
++
++  abstract interface
++     function func_template(state) result(dstate)
++       implicit none
++       real, dimension(:,:), intent(in)              :: state
++       real, dimension(size(state,1), size(state,2)) :: dstate
++     end function
++  end interface
++
++contains
++
++  function zero_state(state) result(dstate)
++    real, dimension(:,:), intent(in)              :: state
++    real, dimension(size(state,1), size(state,2)) :: dstate
++    dstate = 0.
++  end function zero_state
++
++end module m
++
++program test_func_array
++  use m
++  implicit none
++
++  real, dimension(4,6) :: state
++  type(pp) :: func_scalar
++  type(pp) :: func_array(4)
++
++  func_scalar  %f => zero_state
++  func_array(1)%f => zero_state
++  print *, func_scalar  %f(state)
++  print *, func_array(1)%f(state)
++  if (.not. all (shape (func_scalar  %f(state)) == shape (state))) stop 1
++  if (.not. all (shape (func_array(1)%f(state)) == shape (state))) stop 2
++end program test_func_array
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gm2/cpp/fail/cpp-fail.exp
 @@ -0,0 +1,37 @@
 +# Expect driver script for GCC Regression Tests
@@ -431535,6 +434036,29 @@ new file mode 100644
  
    *use->op_p = ref;
  }
+--- a/src/gcc/tree-ssa-loop-niter.cc
++++ b/src/gcc/tree-ssa-loop-niter.cc
+@@ -2299,6 +2299,9 @@ build_cltz_expr (tree src, bool leading, bool define_at_zero)
+ 	src = fold_convert (unsigned_type_node, src);
+ 
+       call = build_call_expr (fn, 1, src);
++      if (leading && prec < i_prec)
++	call = fold_build2 (MINUS_EXPR, integer_type_node, call,
++			    build_int_cst (integer_type_node, i_prec - prec));
+       if (define_at_zero)
+ 	{
+ 	  tree is_zero = fold_build2 (NE_EXPR, boolean_type_node, src,
+@@ -2306,10 +2309,6 @@ build_cltz_expr (tree src, bool leading, bool define_at_zero)
+ 	  call = fold_build3 (COND_EXPR, integer_type_node, is_zero, call,
+ 			      build_int_cst (integer_type_node, prec));
+ 	}
+-
+-      if (leading && prec < i_prec)
+-	call = fold_build2 (MINUS_EXPR, integer_type_node, call,
+-			    build_int_cst (integer_type_node, i_prec - prec));
+     }
+ 
+   return call;
 --- a/src/gcc/tree-ssa-loop-unswitch.cc
 +++ b/src/gcc/tree-ssa-loop-unswitch.cc
 @@ -1454,10 +1454,7 @@ hoist_guard (class loop *loop, edge guard)
@@ -432277,6 +434801,18 @@ new file mode 100644
  					     store
  					     ? SLP_TREE_SCALAR_STMTS (store)
  					     : vNULL, last_store_info))
+@@ -4021,6 +4029,11 @@ vect_check_gather_scatter (stmt_vec_info stmt_info, loop_vec_info loop_vinfo,
+   if (!multiple_p (pbitpos, BITS_PER_UNIT))
+     return false;
+ 
++  /* We need to be able to form an address to the base which for example
++     isn't possible for hard registers.  */
++  if (may_be_nonaddressable_p (base))
++    return false;
++
+   poly_int64 pbytepos = exact_div (pbitpos, BITS_PER_UNIT);
+ 
+   if (TREE_CODE (base) == MEM_REF)
 --- a/src/gcc/tree-vect-generic.cc
 +++ b/src/gcc/tree-vect-generic.cc
 @@ -1367,12 +1367,16 @@ optimize_vector_constructor (gimple_stmt_iterator *gsi)
@@ -432420,7 +434956,31 @@ new file mode 100644
        if (cnt != 1)
  	{
  	  fail = true;
-@@ -8728,13 +8719,26 @@ vect_peel_nonlinear_iv_init (gimple_seq* stmts, tree init_expr,
+@@ -7074,17 +7065,18 @@ vectorizable_reduction (loop_vec_info loop_vinfo,
+ 		  < GET_MODE_SIZE (SCALAR_TYPE_MODE (TREE_TYPE (vectype_op[i]))))))
+ 	vectype_in = vectype_op[i];
+ 
+-      if (op.code == COND_EXPR)
++      /* Record how the non-reduction-def value of COND_EXPR is defined.
++	 ???  For a chain of multiple CONDs we'd have to match them up all.  */
++      if (op.code == COND_EXPR && reduc_chain_length == 1)
+ 	{
+-	  /* Record how the non-reduction-def value of COND_EXPR is defined.  */
+ 	  if (dt == vect_constant_def)
+ 	    {
+ 	      cond_reduc_dt = dt;
+ 	      cond_reduc_val = op.ops[i];
+ 	    }
+-	  if (dt == vect_induction_def
+-	      && def_stmt_info
+-	      && is_nonwrapping_integer_induction (def_stmt_info, loop))
++	  else if (dt == vect_induction_def
++		   && def_stmt_info
++		   && is_nonwrapping_integer_induction (def_stmt_info, loop))
+ 	    {
+ 	      cond_reduc_dt = dt;
+ 	      cond_stmt_vinfo = def_stmt_info;
+@@ -8728,13 +8720,26 @@ vect_peel_nonlinear_iv_init (gimple_seq* stmts, tree init_expr,
        {
  	tree utype = unsigned_type_for (type);
  	init_expr = gimple_convert (stmts, utype, init_expr);
@@ -432438,7 +434998,7 @@ new file mode 100644
 +	wi::to_mpz (skipn, exp, UNSIGNED);
 +	mpz_ui_pow_ui (mod, 2, TYPE_PRECISION (type));
 +	mpz_powm (res, base, exp, mod);
-+	begin = wi::from_mpz (type, res, TYPE_SIGN (type));
++	begin = wi::from_mpz (utype, res, true);
  	tree mult_expr = wide_int_to_tree (utype, begin);
 -	init_expr = gimple_build (stmts, MULT_EXPR, utype, init_expr, mult_expr);
 +	init_expr = gimple_build (stmts, MULT_EXPR, utype,
@@ -432451,7 +435011,7 @@ new file mode 100644
        }
        break;
  
-@@ -8925,9 +8929,16 @@ vectorizable_nonlinear_induction (loop_vec_info loop_vinfo,
+@@ -8925,9 +8930,16 @@ vectorizable_nonlinear_induction (loop_vec_info loop_vinfo,
  
    if (TREE_CODE (init_expr) == INTEGER_CST)
      init_expr = fold_convert (TREE_TYPE (vectype), init_expr);
@@ -432471,7 +435031,7 @@ new file mode 100644
  
    switch (induction_type)
      {
-@@ -9273,6 +9284,15 @@ vectorizable_induction (loop_vec_info loop_vinfo,
+@@ -9273,6 +9285,15 @@ vectorizable_induction (loop_vec_info loop_vinfo,
  
    step_expr = STMT_VINFO_LOOP_PHI_EVOLUTION_PART (stmt_info);
    gcc_assert (step_expr != NULL_TREE);
@@ -432487,7 +435047,7 @@ new file mode 100644
    tree step_vectype = get_same_sized_vectype (TREE_TYPE (step_expr), vectype);
  
    /* Check for backend support of PLUS/MINUS_EXPR. */
-@@ -10520,7 +10540,16 @@ vect_transform_loop_stmt (loop_vec_info loop_vinfo, stmt_vec_info stmt_info,
+@@ -10520,7 +10541,16 @@ vect_transform_loop_stmt (loop_vec_info loop_vinfo, stmt_vec_info stmt_info,
  
    if (!STMT_VINFO_RELEVANT_P (stmt_info)
        && !STMT_VINFO_LIVE_P (stmt_info))
@@ -432507,7 +435067,51 @@ new file mode 100644
      {
 --- a/src/gcc/tree-vect-slp.cc
 +++ b/src/gcc/tree-vect-slp.cc
-@@ -8833,6 +8833,16 @@ vect_schedule_slp_node (vec_info *vinfo,
+@@ -3478,6 +3478,10 @@ vect_analyze_slp (vec_info *vinfo, unsigned max_tree_size)
+       for (unsigned i = 0; i < bb_vinfo->roots.length (); ++i)
+ 	{
+ 	  vect_location = bb_vinfo->roots[i].roots[0]->stmt;
++	  /* Apply patterns.  */
++	  for (unsigned j = 0; j < bb_vinfo->roots[i].stmts.length (); ++j)
++	    bb_vinfo->roots[i].stmts[j]
++	      = vect_stmt_to_vectorize (bb_vinfo->roots[i].stmts[j]);
+ 	  if (vect_build_slp_instance (bb_vinfo, bb_vinfo->roots[i].kind,
+ 				       bb_vinfo->roots[i].stmts,
+ 				       bb_vinfo->roots[i].roots,
+@@ -8777,12 +8781,6 @@ vect_schedule_slp_node (vec_info *vinfo,
+   int i;
+   slp_tree child;
+ 
+-  /* For existing vectors there's nothing to do.  */
+-  if (SLP_TREE_VEC_DEFS (node).exists ())
+-    return;
+-
+-  gcc_assert (SLP_TREE_VEC_STMTS (node).is_empty ());
+-
+   /* Vectorize externals and constants.  */
+   if (SLP_TREE_DEF_TYPE (node) == vect_constant_def
+       || SLP_TREE_DEF_TYPE (node) == vect_external_def)
+@@ -8793,10 +8791,18 @@ vect_schedule_slp_node (vec_info *vinfo,
+       if (!SLP_TREE_VECTYPE (node))
+ 	return;
+ 
+-      vect_create_constant_vectors (vinfo, node);
++      /* There are two reasons vector defs might already exist.  The first
++	 is that we are vectorizing an existing vector def.  The second is
++	 when performing BB vectorization shared constant/external nodes
++	 are not split apart during partitioning so during the code-gen
++	 DFS walk we can end up visiting them twice.  */
++      if (! SLP_TREE_VEC_DEFS (node).exists ())
++	vect_create_constant_vectors (vinfo, node);
+       return;
+     }
+ 
++  gcc_assert (SLP_TREE_VEC_DEFS (node).is_empty ());
++
+   stmt_vec_info stmt_info = SLP_TREE_REPRESENTATIVE (node);
+ 
+   gcc_assert (SLP_TREE_NUMBER_OF_VEC_STMTS (node) != 0);
+@@ -8833,6 +8839,16 @@ vect_schedule_slp_node (vec_info *vinfo,
        /* Emit other stmts after the children vectorized defs which is
  	 earliest possible.  */
        gimple *last_stmt = NULL;
@@ -432524,6 +435128,130 @@ new file mode 100644
        bool seen_vector_def = false;
        FOR_EACH_VEC_ELT (SLP_TREE_CHILDREN (node), i, child)
  	if (SLP_TREE_DEF_TYPE (child) == vect_internal_def)
+--- a/src/gcc/ubsan.cc
++++ b/src/gcc/ubsan.cc
+@@ -1401,7 +1401,7 @@ instrument_mem_ref (tree mem, tree base, gimple_stmt_iterator *iter,
+   tree alignt = build_int_cst (pointer_sized_int_node, align);
+   gcall *g = gimple_build_call_internal (IFN_UBSAN_NULL, 3, t, kind, alignt);
+   gimple_set_location (g, gimple_location (gsi_stmt (*iter)));
+-  gsi_insert_before (iter, g, GSI_SAME_STMT);
++  gsi_safe_insert_before (iter, g);
+ }
+ 
+ /* Perform the pointer instrumentation.  */
+@@ -1428,7 +1428,7 @@ instrument_pointer_overflow (gimple_stmt_iterator *gsi, tree ptr, tree off)
+     return;
+   gcall *g = gimple_build_call_internal (IFN_UBSAN_PTR, 2, ptr, off);
+   gimple_set_location (g, gimple_location (gsi_stmt (*gsi)));
+-  gsi_insert_before (gsi, g, GSI_SAME_STMT);
++  gsi_safe_insert_before (gsi, g);
+ }
+ 
+ /* Instrument pointer arithmetics if any.  */
+@@ -1520,10 +1520,11 @@ maybe_instrument_pointer_overflow (gimple_stmt_iterator *gsi, tree t)
+       else
+ 	t = fold_convert (sizetype, moff);
+     }
+-  t = force_gimple_operand_gsi (gsi, t, true, NULL_TREE, true,
+-				GSI_SAME_STMT);
+-  base_addr = force_gimple_operand_gsi (gsi, base_addr, true, NULL_TREE, true,
+-					GSI_SAME_STMT);
++  gimple_seq seq, this_seq;
++  t = force_gimple_operand (t, &seq, true, NULL_TREE);
++  base_addr = force_gimple_operand (base_addr, &this_seq, true, NULL_TREE);
++  gimple_seq_add_seq_without_update (&seq, this_seq);
++  gsi_safe_insert_seq_before (gsi, seq);
+   instrument_pointer_overflow (gsi, base_addr, t);
+ }
+ 
+@@ -1979,7 +1980,7 @@ instrument_nonnull_arg (gimple_stmt_iterator *gsi)
+ 	    {
+ 	      g = gimple_build_assign (make_ssa_name (TREE_TYPE (arg)), arg);
+ 	      gimple_set_location (g, loc[0]);
+-	      gsi_insert_before (gsi, g, GSI_SAME_STMT);
++	      gsi_safe_insert_before (gsi, g);
+ 	      arg = gimple_assign_lhs (g);
+ 	    }
+ 
+@@ -2012,7 +2013,7 @@ instrument_nonnull_arg (gimple_stmt_iterator *gsi)
+ 	      g = gimple_build_call (fn, 1, data);
+ 	    }
+ 	  gimple_set_location (g, loc[0]);
+-	  gsi_insert_before (gsi, g, GSI_SAME_STMT);
++	  gsi_safe_insert_before (gsi, g);
+ 	  ubsan_create_edge (g);
+ 	}
+       *gsi = gsi_for_stmt (stmt);
+@@ -2068,7 +2069,7 @@ instrument_nonnull_return (gimple_stmt_iterator *gsi)
+ 	  g = gimple_build_call (fn, 2, data, data2);
+ 	}
+       gimple_set_location (g, loc[0]);
+-      gsi_insert_before (gsi, g, GSI_SAME_STMT);
++      gsi_safe_insert_before (gsi, g);
+       ubsan_create_edge (g);
+       *gsi = gsi_for_stmt (stmt);
+     }
+@@ -2175,6 +2176,7 @@ instrument_object_size (gimple_stmt_iterator *gsi, tree t, bool is_lhs)
+   tree sizet;
+   tree base_addr = base;
+   gimple *bos_stmt = NULL;
++  gimple_seq seq = NULL;
+   if (decl_p)
+     base_addr = build1 (ADDR_EXPR,
+ 			build_pointer_type (TREE_TYPE (base)), base);
+@@ -2188,19 +2190,12 @@ instrument_object_size (gimple_stmt_iterator *gsi, tree t, bool is_lhs)
+       sizet = builtin_decl_explicit (BUILT_IN_DYNAMIC_OBJECT_SIZE);
+       sizet = build_call_expr_loc (loc, sizet, 2, base_addr,
+ 				   integer_zero_node);
+-      sizet = force_gimple_operand_gsi (gsi, sizet, false, NULL_TREE, true,
+-					GSI_SAME_STMT);
++      sizet = force_gimple_operand (sizet, &seq, false, NULL_TREE);
+       /* If the call above didn't end up being an integer constant, go one
+ 	 statement back and get the __builtin_object_size stmt.  Save it,
+ 	 we might need it later.  */
+       if (SSA_VAR_P (sizet))
+-	{
+-	  gsi_prev (gsi);
+-	  bos_stmt = gsi_stmt (*gsi);
+-
+-	  /* Move on to where we were.  */
+-	  gsi_next (gsi);
+-	}
++	bos_stmt = gsi_stmt (gsi_last (seq));
+     }
+   else
+     return;
+@@ -2242,21 +2237,24 @@ instrument_object_size (gimple_stmt_iterator *gsi, tree t, bool is_lhs)
+       && !TREE_ADDRESSABLE (base))
+     mark_addressable (base);
+ 
++  /* We have to emit the check.  */
++  gimple_seq this_seq;
++  t = force_gimple_operand (t, &this_seq, true, NULL_TREE);
++  gimple_seq_add_seq_without_update (&seq, this_seq);
++  ptr = force_gimple_operand (ptr, &this_seq, true, NULL_TREE);
++  gimple_seq_add_seq_without_update (&seq, this_seq);
++  gsi_safe_insert_seq_before (gsi, seq);
++
+   if (bos_stmt
+       && gimple_call_builtin_p (bos_stmt, BUILT_IN_DYNAMIC_OBJECT_SIZE))
+     ubsan_create_edge (bos_stmt);
+ 
+-  /* We have to emit the check.  */
+-  t = force_gimple_operand_gsi (gsi, t, true, NULL_TREE, true,
+-				GSI_SAME_STMT);
+-  ptr = force_gimple_operand_gsi (gsi, ptr, true, NULL_TREE, true,
+-				  GSI_SAME_STMT);
+   tree ckind = build_int_cst (unsigned_char_type_node,
+ 			      is_lhs ? UBSAN_STORE_OF : UBSAN_LOAD_OF);
+   gimple *g = gimple_build_call_internal (IFN_UBSAN_OBJECT_SIZE, 4,
+ 					 ptr, t, sizet, ckind);
+   gimple_set_location (g, loc);
+-  gsi_insert_before (gsi, g, GSI_SAME_STMT);
++  gsi_safe_insert_before (gsi, g);
+ }
+ 
+ /* Instrument values passed to builtin functions.  */
 --- a/src/gcc/value-range-storage.h
 +++ b/src/gcc/value-range-storage.h
 @@ -184,7 +184,7 @@ vrange_allocator::alloc_irange (unsigned num_pairs)
@@ -436885,7 +439613,93 @@ new file mode 100644
  void BufferedStackTrace::UnwindSlow(uptr pc, void *context, u32 max_depth) {
 --- a/src/libstdc++-v3/ChangeLog
 +++ b/src/libstdc++-v3/ChangeLog
-@@ -1,3 +1,1677 @@
+@@ -1,3 +1,1763 @@
++2024-03-20  François Dumont  <fdumont@gcc.gnu.org>
++
++	* include/std/iterator (__cpp_lib_null_iterators): Define regardless of
++	_GLIBCXX_DEBUG.
++	* include/std/version (__cpp_lib_null_iterators): Likewise.
++
++2024-03-20  François Dumont  <fdumont@gcc.gnu.org>
++
++	Backported from master:
++	2024-03-18  François Dumont  <fdumont@gcc.gnu.org>
++
++	* include/debug/safe_iterator.tcc (_Safe_iterator<>::_M_can_advance):
++	Accept 0 offset advance on value-initialized iterator.
++	* testsuite/23_containers/vector/debug/n3644.cc: New test case.
++
++2024-03-20  François Dumont  <fdumont@gcc.gnu.org>
++
++	Backported from master:
++	2024-03-18  François Dumont  <fdumont@gcc.gnu.org>
++
++	* include/debug/safe_local_iterator.tcc
++	(_Safe_local_iterator::_M_valid_range): Add _M_value_initialized and
++	_M_singular checks.
++	* testsuite/23_containers/unordered_set/debug/114316.cc: New test case.
++
++2024-03-18  Jonathan Wakely  <jwakely@redhat.com>
++
++	Backported from master:
++	2024-03-14  Jonathan Wakely  <jwakely@redhat.com>
++
++	PR libstdc++/66146
++	* doc/xml/manual/status_cxx2011.xml: Remove mention of Linux in
++	note about std::call_once.
++	* doc/xml/manual/status_cxx2014.xml: Likewise.
++	* doc/xml/manual/status_cxx2017.xml: Likewise.
++	* doc/html/manual/status.html: Regenerate.
++
++2024-03-18  Jonathan Wakely  <jwakely@redhat.com>
++
++	Backported from master:
++	2024-03-13  Jonathan Wakely  <jwakely@redhat.com>
++
++	* testsuite/libstdc++-prettyprinters/cxx11.cc: Move custom_cat
++	to namespace scope.
++
++2024-03-17  François Dumont  <fdumont@gcc.gnu.org>
++
++	Backported from master:
++	2024-03-17  François Dumont  <fdumont@gcc.gnu.org>
++
++	PR libstdc++/114316
++	* include/debug/safe_iterator.tcc (_Safe_iterator<>::_M_valid_range):
++	First check if both iterators are value-initialized before checking if
++	singular.
++	* testsuite/23_containers/set/debug/114316.cc: New test case.
++	* testsuite/23_containers/vector/debug/114316.cc: New test case.
++
++2024-03-16  Jonathan Wakely  <jwakely@redhat.com>
++
++	Backported from master:
++	2023-08-17  Jonathan Wakely  <jwakely@redhat.com>
++
++	* include/bits/chrono_io.h (__units_suffix_misc): Remove.
++	(__units_suffix): Return a known suffix as string view, do not
++	write unknown suffixes to a buffer.
++	(__fmt_units_suffix): New function that formats the suffix using
++	std::format_to.
++	(operator<<, __chrono_formatter::_M_q): Use __fmt_units_suffix.
++	(__chrono_formatter::_M_Z): Correct lifetime of wstring.
++
++2024-03-16  Jonathan Wakely  <jwakely@redhat.com>
++
++	Backported from master:
++	2024-03-04  Jonathan Wakely  <jwakely@redhat.com>
++
++	PR libstdc++/114147
++	* include/std/tuple (tuple::tuple(allocator_arg_t, const Alloc&)):
++	Add missing overload of allocator-extended default constructor.
++	(tuple<T1,T2>::tuple(allocator_arg_t, const Alloc&)): Likewise.
++	* testsuite/20_util/tuple/cons/114147.cc: New test.
++
++2024-03-15  Jonathan Wakely  <jwakely@redhat.com>
++
++	* doc/xml/manual/status_cxx2023.xml: Close parenthesis.
++	* doc/html/manual/status.html: Regenerate.
++
 +2024-03-12  Jonathan Wakely  <jwakely@redhat.com>
 +
 +	Backported from master:
@@ -439184,6 +441998,33 @@ new file mode 100644
        else, there is an 80 column source limit.<br />
 --- a/src/libstdc++-v3/doc/html/manual/status.html
 +++ b/src/libstdc++-v3/doc/html/manual/status.html
+@@ -217,7 +217,7 @@ particular release.
+ 	<span class="emphasis"><em>30</em></span>
+       </td><td colspan="3" align="left">
+ 	<span class="emphasis"><em>Thread support</em></span>
+-      </td></tr><tr><td align="left">30.1</td><td align="left">General</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.2</td><td align="left">Requirements</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.3</td><td align="left">Threads</td><td align="left"> </td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">30.3.1</td><td align="left">Class <code class="code">thread</code></td><td align="left">Partial</td><td align="left"><code class="code">thread::id</code> comparisons not well-defined</td></tr><tr><td align="left">30.3.2</td><td align="left">Namespace <code class="code">this_thread</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4</td><td align="left">Mutual exclusion</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1</td><td align="left">Mutex requirements</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.1</td><td align="left">In general</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.2</td><td align="left">Mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.2.1</td><td align="left">Class <code class="code">mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.2.2</td><td align="left">Class <code class="code">recursive_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.3</td><td align="left">Timed mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.3.1</td><td align="left">Class <code class="code">timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.3.2</td><td align="left">Class <code class="code">recursive_timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.2</td><td align="left">Locks</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.2.1</td><td align="left">Class template <code class="code">lock_guard</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.2.2</td><td align="left">Class template <code class="code">unique_lock</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.3</td><td align="left">Generic locking algorithms</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.4</td><td align="left">Call once</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.4.1</td><td align="left">Struct <code class="code">once_flag</code></td><td align="left">Y</td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">30.4.4.2</td><td align="left">Function <code class="code">call_once</code></td><td align="left">Y</td><td align="left">Exception support is broken on non-Linux targets.
++      </td></tr><tr><td align="left">30.1</td><td align="left">General</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.2</td><td align="left">Requirements</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.3</td><td align="left">Threads</td><td align="left"> </td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">30.3.1</td><td align="left">Class <code class="code">thread</code></td><td align="left">Partial</td><td align="left"><code class="code">thread::id</code> comparisons not well-defined</td></tr><tr><td align="left">30.3.2</td><td align="left">Namespace <code class="code">this_thread</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4</td><td align="left">Mutual exclusion</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1</td><td align="left">Mutex requirements</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.1</td><td align="left">In general</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.2</td><td align="left">Mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.2.1</td><td align="left">Class <code class="code">mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.2.2</td><td align="left">Class <code class="code">recursive_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.3</td><td align="left">Timed mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.3.1</td><td align="left">Class <code class="code">timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.3.2</td><td align="left">Class <code class="code">recursive_timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.2</td><td align="left">Locks</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.2.1</td><td align="left">Class template <code class="code">lock_guard</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.2.2</td><td align="left">Class template <code class="code">unique_lock</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.3</td><td align="left">Generic locking algorithms</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.4</td><td align="left">Call once</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.4.1</td><td align="left">Struct <code class="code">once_flag</code></td><td align="left">Y</td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">30.4.4.2</td><td align="left">Function <code class="code">call_once</code></td><td align="left">Y</td><td align="left">Exception support is broken.
+ 	See <a class="link" href="https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66146" target="_top">PR
+ 	66146</a>.
+       </td></tr><tr><td align="left">30.5</td><td align="left">Condition variables</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.5.1</td><td align="left">Class <code class="code">condition_variable</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.5.2</td><td align="left">Class <code class="code">condition_variable_any</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6</td><td align="left">Futures</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.6.1</td><td align="left">Overview</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.6.2</td><td align="left">Error handling</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.3</td><td align="left">Class <code class="code">future_error</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.4</td><td align="left">Shared state</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.5</td><td align="left">Class template <code class="code">promise</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.6</td><td align="left">Class template <code class="code">future</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.7</td><td align="left">Class template <code class="code">shared_future</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.8</td><td align="left">Function template <code class="code">async</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.9</td><td align="left">Class template <code class="code">packaged_task</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">
+@@ -490,7 +490,7 @@ not in any particular release.
+ 	<span class="emphasis"><em>30</em></span>
+       </td><td colspan="3" align="left">
+ 	<span class="emphasis"><em>Thread support</em></span>
+-      </td></tr><tr><td align="left">30.1</td><td align="left">General</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.2</td><td align="left">Requirements</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.3</td><td align="left">Threads</td><td align="left"> </td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">30.3.1</td><td align="left">Class <code class="code">thread</code></td><td align="left">Partial</td><td align="left"><code class="code">thread::id</code> comparisons not well-defined</td></tr><tr><td align="left">30.3.2</td><td align="left">Namespace <code class="code">this_thread</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4</td><td align="left">Mutual exclusion</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1</td><td align="left">Mutex requirements</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.1</td><td align="left">In general</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.2</td><td align="left">Mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.2.1</td><td align="left">Class <code class="code">mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.2.2</td><td align="left">Class <code class="code">recursive_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.3</td><td align="left">Timed mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.3.1</td><td align="left">Class <code class="code">timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.3.2</td><td align="left">Class <code class="code">recursive_timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.4</td><td align="left">Shared timed mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.4.1</td><td align="left">Class <code class="code">shared_timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.2</td><td align="left">Locks</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.2.1</td><td align="left">Class template <code class="code">lock_guard</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.2.2</td><td align="left">Class template <code class="code">unique_lock</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.2.3</td><td align="left">Class template <code class="code">shared_lock</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.3</td><td align="left">Generic locking algorithms</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.4</td><td align="left">Call once</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.4.1</td><td align="left">Struct <code class="code">once_flag</code></td><td align="left">Y</td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">30.4.4.2</td><td align="left">Function <code class="code">call_once</code></td><td align="left">Broken</td><td align="left">Exception support is broken on non-Linux targets.
++      </td></tr><tr><td align="left">30.1</td><td align="left">General</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.2</td><td align="left">Requirements</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.3</td><td align="left">Threads</td><td align="left"> </td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">30.3.1</td><td align="left">Class <code class="code">thread</code></td><td align="left">Partial</td><td align="left"><code class="code">thread::id</code> comparisons not well-defined</td></tr><tr><td align="left">30.3.2</td><td align="left">Namespace <code class="code">this_thread</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4</td><td align="left">Mutual exclusion</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1</td><td align="left">Mutex requirements</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.1</td><td align="left">In general</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.2</td><td align="left">Mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.2.1</td><td align="left">Class <code class="code">mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.2.2</td><td align="left">Class <code class="code">recursive_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.3</td><td align="left">Timed mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.3.1</td><td align="left">Class <code class="code">timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.3.2</td><td align="left">Class <code class="code">recursive_timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.1.4</td><td align="left">Shared timed mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.1.4.1</td><td align="left">Class <code class="code">shared_timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.2</td><td align="left">Locks</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.2.1</td><td align="left">Class template <code class="code">lock_guard</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.2.2</td><td align="left">Class template <code class="code">unique_lock</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.2.3</td><td align="left">Class template <code class="code">shared_lock</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.3</td><td align="left">Generic locking algorithms</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.4.4</td><td align="left">Call once</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.4.4.1</td><td align="left">Struct <code class="code">once_flag</code></td><td align="left">Y</td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">30.4.4.2</td><td align="left">Function <code class="code">call_once</code></td><td align="left">Broken</td><td align="left">Exception support is broken.
+ 	See <a class="link" href="https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66146" target="_top">PR
+ 	66146</a>.
+       </td></tr><tr><td align="left">30.5</td><td align="left">Condition variables</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.5.1</td><td align="left">Class <code class="code">condition_variable</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.5.2</td><td align="left">Class <code class="code">condition_variable_any</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6</td><td align="left">Futures</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.6.1</td><td align="left">Overview</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">30.6.2</td><td align="left">Error handling</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.3</td><td align="left">Class <code class="code">future_error</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.4</td><td align="left">Shared state</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.5</td><td align="left">Class template <code class="code">promise</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.6</td><td align="left">Class template <code class="code">future</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.7</td><td align="left">Class template <code class="code">shared_future</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.8</td><td align="left">Function template <code class="code">async</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">30.6.9</td><td align="left">Class template <code class="code">packaged_task</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">
+@@ -967,7 +967,7 @@ since C++14 and the implementation is complete.
+ 	<span class="emphasis"><em>33</em></span>
+       </td><td colspan="3" align="left">
+ 	<span class="emphasis"><em>Thread support</em></span>
+-      </td></tr><tr><td align="left">33.1</td><td align="left">General</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.2</td><td align="left">Requirements</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.3</td><td align="left">Threads</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.3.1</td><td align="left">Header <code class="code">thread</code> synopsis</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.3.2</td><td align="left">Class <code class="code">thread</code></td><td align="left">Y</td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">33.3.2.1</td><td align="left">Class <code class="code">thread</code></td><td align="left">Partial</td><td align="left"><code class="code">thread::id</code> comparisons not well-defined</td></tr><tr><td align="left">33.3.3</td><td align="left">Namespace <code class="code">this_thread</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4</td><td align="left">Mutual exclusion</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3</td><td align="left">Mutex requirements</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.1</td><td align="left">In general</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.2</td><td align="left">Mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.2.1</td><td align="left">Class <code class="code">mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.3.2.2</td><td align="left">Class <code class="code">recursive_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.3.3</td><td align="left">Timed mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.3.1</td><td align="left">Class <code class="code">timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.3.3.2</td><td align="left">Class <code class="code">recursive_timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.3.4</td><td align="left">Shared mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.4.1</td><td align="left">Class <code class="code">shared_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.3.5</td><td align="left">Shared timed mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.5.1</td><td align="left">Class <code class="code">shared_timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.4</td><td align="left">Locks</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.4.1</td><td align="left">Class template <code class="code">lock_guard</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.4.2</td><td align="left">Class template <code class="code">scoped_guard</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.4.3</td><td align="left">Class template <code class="code">unique_lock</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.4.4</td><td align="left">Class template <code class="code">shared_lock</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.5</td><td align="left">Generic locking algorithms</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.6</td><td align="left">Call once</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.6.1</td><td align="left">Struct <code class="code">once_flag</code></td><td align="left">Y</td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">33.4.6.2</td><td align="left">Function <code class="code">call_once</code></td><td align="left">Y</td><td align="left">Exception support is broken on non-Linux targets.
++      </td></tr><tr><td align="left">33.1</td><td align="left">General</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.2</td><td align="left">Requirements</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.3</td><td align="left">Threads</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.3.1</td><td align="left">Header <code class="code">thread</code> synopsis</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.3.2</td><td align="left">Class <code class="code">thread</code></td><td align="left">Y</td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">33.3.2.1</td><td align="left">Class <code class="code">thread</code></td><td align="left">Partial</td><td align="left"><code class="code">thread::id</code> comparisons not well-defined</td></tr><tr><td align="left">33.3.3</td><td align="left">Namespace <code class="code">this_thread</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4</td><td align="left">Mutual exclusion</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3</td><td align="left">Mutex requirements</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.1</td><td align="left">In general</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.2</td><td align="left">Mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.2.1</td><td align="left">Class <code class="code">mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.3.2.2</td><td align="left">Class <code class="code">recursive_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.3.3</td><td align="left">Timed mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.3.1</td><td align="left">Class <code class="code">timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.3.3.2</td><td align="left">Class <code class="code">recursive_timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.3.4</td><td align="left">Shared mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.4.1</td><td align="left">Class <code class="code">shared_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.3.5</td><td align="left">Shared timed mutex types</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.3.5.1</td><td align="left">Class <code class="code">shared_timed_mutex</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.4</td><td align="left">Locks</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.4.1</td><td align="left">Class template <code class="code">lock_guard</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.4.2</td><td align="left">Class template <code class="code">scoped_guard</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.4.3</td><td align="left">Class template <code class="code">unique_lock</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.4.4</td><td align="left">Class template <code class="code">shared_lock</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.5</td><td align="left">Generic locking algorithms</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.4.6</td><td align="left">Call once</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.4.6.1</td><td align="left">Struct <code class="code">once_flag</code></td><td align="left">Y</td><td align="left"> </td></tr><tr bgcolor="#B0B0B0"><td align="left">33.4.6.2</td><td align="left">Function <code class="code">call_once</code></td><td align="left">Y</td><td align="left">Exception support is broken.
+ 	See <a class="link" href="https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66146" target="_top">PR
+ 	66146</a>.
+       </td></tr><tr><td align="left">33.5</td><td align="left">Condition variables</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.5.1</td><td align="left">Class <code class="code">condition_variable</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.5.2</td><td align="left">Class <code class="code">condition_variable_any</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.6</td><td align="left">Futures</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.6.1</td><td align="left">Overview</td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.6.2</td><td align="left">Header <code class="code">&lt;future&gt;</code></td><td align="left"> </td><td align="left"> </td></tr><tr><td align="left">33.6.3</td><td align="left">Error handling</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.6.4</td><td align="left">Class <code class="code">future_error</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.6.5</td><td align="left">Shared state</td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.6.6</td><td align="left">Class template <code class="code">promise</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.6.7</td><td align="left">Class template <code class="code">future</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.6.8</td><td align="left">Class template <code class="code">shared_future</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.6.9</td><td align="left">Function template <code class="code">async</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">33.6.10</td><td align="left">Class template <code class="code">packaged_task</code></td><td align="left">Y</td><td align="left"> </td></tr><tr><td align="left">
 @@ -1325,10 +1325,10 @@ or any notes about the implementation.
        </td><td align="center"> 9.1 </td><td align="left"> <code class="code">__cpp_lib_type_identity &gt;= 201806L</code> (since 9.4, see Note 1) </td></tr><tr><td align="left">  <code class="code">unwrap_ref_decay</code> and <code class="code">unwrap_reference</code> </td><td align="left">
          <a class="link" href="https://www.open-std.org/jtc1/sc22/wg21/docs/papers/2018/p0318r1.pdf" target="_top">
@@ -439434,7 +442275,7 @@ new file mode 100644
          P2255R2
          </a>
 -      </td><td align="center"> </td><td align="left"> <code class="code">__cpp_lib_reference_from_temporary &gt;= 202202L</code> </td></tr><tr><td colspan="4" align="left">
-+      </td><td align="center"> 13.1 (missing changes to <code class="code">std::tuple</code> </td><td align="left"> <code class="code">__cpp_lib_reference_from_temporary &gt;= 202202L</code> </td></tr><tr><td colspan="4" align="left">
++      </td><td align="center"> 13.1 (missing changes to <code class="code">std::tuple</code>) </td><td align="left"> <code class="code">__cpp_lib_reference_from_temporary &gt;= 202202L</code> </td></tr><tr><td colspan="4" align="left">
          <span class="bold"><strong>Strings and text</strong></span>
        </td></tr><tr><td align="left"> string contains function </td><td align="left">
          <a class="link" href="https://www.open-std.org/jtc1/sc22/wg21/docs/papers/2020/p1679r3.html" target="_top">
@@ -439775,6 +442616,39 @@ new file mode 100644
  </section>
  
  </section>
+--- a/src/libstdc++-v3/doc/xml/manual/status_cxx2011.xml
++++ b/src/libstdc++-v3/doc/xml/manual/status_cxx2011.xml
+@@ -2404,7 +2404,7 @@ particular release.
+       <entry>30.4.4.2</entry>
+       <entry>Function <code>call_once</code></entry>
+       <entry>Y</entry>
+-      <entry>Exception support is broken on non-Linux targets.
++      <entry>Exception support is broken.
+ 	See <link xmlns:xlink="http://www.w3.org/1999/xlink"
+ 	xlink:href="https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66146">PR
+ 	66146</link>.
+--- a/src/libstdc++-v3/doc/xml/manual/status_cxx2014.xml
++++ b/src/libstdc++-v3/doc/xml/manual/status_cxx2014.xml
+@@ -1390,7 +1390,7 @@ not in any particular release.
+       <entry>30.4.4.2</entry>
+       <entry>Function <code>call_once</code></entry>
+       <entry>Broken</entry>
+-      <entry>Exception support is broken on non-Linux targets.
++      <entry>Exception support is broken.
+ 	See <link xmlns:xlink="http://www.w3.org/1999/xlink"
+ 	xlink:href="https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66146">PR
+ 	66146</link>.
+--- a/src/libstdc++-v3/doc/xml/manual/status_cxx2017.xml
++++ b/src/libstdc++-v3/doc/xml/manual/status_cxx2017.xml
+@@ -2505,7 +2505,7 @@ since C++14 and the implementation is complete.
+       <entry>33.4.6.2</entry>
+       <entry>Function <code>call_once</code></entry>
+       <entry>Y</entry>
+-      <entry>Exception support is broken on non-Linux targets.
++      <entry>Exception support is broken.
+ 	See <link xmlns:xlink="http://www.w3.org/1999/xlink"
+ 	xlink:href="https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66146">PR
+ 	66146</link>.
 --- a/src/libstdc++-v3/doc/xml/manual/status_cxx2020.xml
 +++ b/src/libstdc++-v3/doc/xml/manual/status_cxx2020.xml
 @@ -251,14 +251,13 @@ or any notes about the implementation.
@@ -440202,7 +443076,7 @@ new file mode 100644
          </link>
        </entry>
 -      <entry align="center"> </entry>
-+      <entry align="center"> 13.1 (missing changes to <code>std::tuple</code> </entry>
++      <entry align="center"> 13.1 (missing changes to <code>std::tuple</code>) </entry>
        <entry> <code>__cpp_lib_reference_from_temporary &gt;= 202202L</code> </entry>
      </row>
  
@@ -440995,7 +443869,94 @@ new file mode 100644
      };
 --- a/src/libstdc++-v3/include/bits/chrono_io.h
 +++ b/src/libstdc++-v3/include/bits/chrono_io.h
-@@ -414,11 +414,10 @@ namespace __format
+@@ -38,7 +38,7 @@
+ #include <iomanip> // setw, setfill
+ #include <format>
+ 
+-#include <bits/charconv.h>
++#include <bits/streambuf_iterator.h>
+ 
+ namespace std _GLIBCXX_VISIBILITY(default)
+ {
+@@ -69,34 +69,9 @@ namespace __detail
+ #define _GLIBCXX_WIDEN_(C, S) ::std::chrono::__detail::_Widen<C>(S, L##S)
+ #define _GLIBCXX_WIDEN(S) _GLIBCXX_WIDEN_(_CharT, S)
+ 
+-
+-  // Write an arbitrary duration suffix into the buffer.
+-  template<typename _Period>
+-    constexpr const char*
+-    __units_suffix_misc(char* __buf, size_t /* TODO check length? */) noexcept
+-    {
+-      namespace __tc = std::__detail;
+-      char* __p = __buf;
+-      __p[0] = '[';
+-      unsigned __nlen = __tc::__to_chars_len((uintmax_t)_Period::num);
+-      __tc::__to_chars_10_impl(__p + 1, __nlen, (uintmax_t)_Period::num);
+-      __p += 1 + __nlen;
+-      if constexpr (_Period::den != 1)
+-	{
+-	  __p[0] = '/';
+-	  unsigned __dlen = __tc::__to_chars_len((uintmax_t)_Period::den);
+-	  __tc::__to_chars_10_impl(__p + 1, __dlen, (uintmax_t)_Period::den);
+-	  __p += 1 + __dlen;
+-	}
+-      __p[0] = ']';
+-      __p[1] = 's';
+-      __p[2] = '\0';
+-      return __buf;
+-    }
+-
+   template<typename _Period, typename _CharT>
+-    constexpr auto
+-    __units_suffix(char* __buf, size_t __n) noexcept
++    constexpr basic_string_view<_CharT>
++    __units_suffix() noexcept
+     {
+       // The standard say these are all narrow strings, which would need to
+       // be widened at run-time when inserted into a wide stream. We use
+@@ -134,7 +109,22 @@ namespace __detail
+       _GLIBCXX_UNITS_SUFFIX(ratio<3600>,  "h")
+       _GLIBCXX_UNITS_SUFFIX(ratio<86400>, "d")
+ #undef _GLIBCXX_UNITS_SUFFIX
+-      return __detail::__units_suffix_misc<_Period>(__buf, __n);
++	return {};
++    }
++
++  template<typename _Period, typename _CharT, typename _Out>
++    inline _Out
++    __fmt_units_suffix(_Out __out) noexcept
++    {
++      if (auto __s = __detail::__units_suffix<_Period, _CharT>(); __s.size())
++	return __format::__write(std::move(__out), __s);
++      else if constexpr (_Period::den == 1)
++	return std::format_to(std::move(__out), _GLIBCXX_WIDEN("[{}]s"),
++			      (uintmax_t)_Period::num);
++      else
++	return std::format_to(std::move(__out), _GLIBCXX_WIDEN("[{}/{}]s"),
++			      (uintmax_t)_Period::num,
++			      (uintmax_t)_Period::den);
+     }
+ } // namespace __detail
+ /// @endcond
+@@ -149,14 +139,14 @@ namespace __detail
+     operator<<(std::basic_ostream<_CharT, _Traits>& __os,
+ 	       const duration<_Rep, _Period>& __d)
+     {
++      using _Out = ostreambuf_iterator<_CharT, _Traits>;
+       using period = typename _Period::type;
+-      char __buf[sizeof("[/]s") + 2 * numeric_limits<intmax_t>::digits10];
+       std::basic_ostringstream<_CharT, _Traits> __s;
+       __s.flags(__os.flags());
+       __s.imbue(__os.getloc());
+       __s.precision(__os.precision());
+       __s << __d.count();
+-      __s << __detail::__units_suffix<period, _CharT>(__buf, sizeof(__buf));
++      __detail::__fmt_units_suffix<period, _CharT>(_Out(__s));
+       __os << std::move(__s).str();
+       return __os;
+     }
+@@ -414,11 +404,10 @@ namespace __format
  		  break;
  		case 'z':
  		  __needed = _TimeZone;
@@ -441008,7 +443969,7 @@ new file mode 100644
  		  break;
  		case 'n':
  		case 't':
-@@ -426,6 +425,11 @@ namespace __format
+@@ -426,6 +415,11 @@ namespace __format
  		  break;
  		case 'O':
  		case 'E':
@@ -441020,7 +443981,7 @@ new file mode 100644
  		  __mod = __c;
  		  continue;
  		default:
-@@ -434,7 +438,7 @@ namespace __format
+@@ -434,7 +428,7 @@ namespace __format
  		}
  
  	      if ((__mod == 'E' && !(__allowed_mods & _Mod_E))
@@ -441029,7 +443990,7 @@ new file mode 100644
  		__throw_format_error("chrono format error: invalid "
  				     " modifier in chrono-specs");
  	      __mod = _CharT();
-@@ -466,7 +470,8 @@ namespace __format
+@@ -466,7 +460,8 @@ namespace __format
  				 "chrono-specs");
  
  	  _M_spec = __spec;
@@ -441039,7 +444000,7 @@ new file mode 100644
  
  	  return __first;
  	}
-@@ -481,11 +486,6 @@ namespace __format
+@@ -481,11 +476,6 @@ namespace __format
  	_M_format(const _Tp& __t, _FormatContext& __fc,
  		  bool __is_neg = false) const
  	{
@@ -441051,7 +444012,7 @@ new file mode 100644
  	  auto __first = _M_spec._M_chrono_specs.begin();
  	  const auto __last = _M_spec._M_chrono_specs.end();
  	  if (__first == __last)
-@@ -508,12 +508,19 @@ namespace __format
+@@ -508,12 +498,19 @@ namespace __format
  	  else
  	    __out = __sink.out();
  
@@ -441076,7 +444037,7 @@ new file mode 100644
  	    return std::move(__out);
  	  };
  
-@@ -546,18 +553,12 @@ namespace __format
+@@ -546,18 +543,12 @@ namespace __format
  		  __out = _M_C_y_Y(__t, std::move(__out), __fc, __c, __mod);
  		  break;
  		case 'd':
@@ -441097,7 +444058,7 @@ new file mode 100644
  		case 'F':
  		  __out = _M_F(__t, std::move(__out), __fc);
  		  break;
-@@ -566,29 +567,17 @@ namespace __format
+@@ -566,29 +557,17 @@ namespace __format
  		  __out = _M_g_G(__t, std::move(__out), __fc, __c == 'G');
  		  break;
  		case 'H':
@@ -441130,7 +444091,7 @@ new file mode 100644
  		  break;
  		case 'p':
  		  __out = _M_p(__t, std::move(__out), __fc);
-@@ -698,6 +687,7 @@ namespace __format
+@@ -698,6 +677,7 @@ namespace __format
  	    return __fc.locale();
  	}
  
@@ -441138,7 +444099,7 @@ new file mode 100644
        // TODO: consider moving body of every operator<< into this function
        // and use std::format("{}", t) to implement those operators. That
        // would avoid std::format("{}", t) calling operator<< which calls
-@@ -719,10 +709,27 @@ namespace __format
+@@ -719,10 +699,27 @@ namespace __format
  
  	      if constexpr (__is_specialization_of<_Tp, __utc_leap_second>)
  		__os << __t._M_date << ' ' << __t._M_time;
@@ -441168,7 +444129,7 @@ new file mode 100644
  		  __os << __t;
  		}
  
-@@ -785,12 +792,13 @@ namespace __format
+@@ -785,12 +782,13 @@ namespace __format
  
        template<typename _Tp, typename _FormatContext>
  	typename _FormatContext::iterator
@@ -441183,7 +444144,7 @@ new file mode 100644
  	  locale __loc = _M_locale(__ctx);
  	  const auto& __tp = use_facet<__timepunct<_CharT>>(__loc);
  	  const _CharT* __formats[2];
-@@ -808,22 +816,24 @@ namespace __format
+@@ -808,22 +806,24 @@ namespace __format
        template<typename _Tp, typename _FormatContext>
  	typename _FormatContext::iterator
  	_M_C_y_Y(const _Tp& __t, typename _FormatContext::iterator __out,
@@ -441214,7 +444175,7 @@ new file mode 100644
  	    }
  
  	  basic_string<_CharT> __s;
-@@ -833,9 +843,14 @@ namespace __format
+@@ -833,9 +833,14 @@ namespace __format
  
  	  if (__conv == 'Y' || __conv == 'C')
  	    {
@@ -441231,7 +444192,7 @@ new file mode 100644
  	      if (__ci >= 100) [[unlikely]]
  		{
  		  __s += std::format(_S_empty_spec, __ci / 100);
-@@ -847,9 +862,6 @@ namespace __format
+@@ -847,9 +852,6 @@ namespace __format
  	  if (__conv == 'Y' || __conv == 'y')
  	    __s += _S_two_digits(__yi % 100);
  
@@ -441241,7 +444202,7 @@ new file mode 100644
  	  return __format::__write(std::move(__out), __string_view(__s));
  	}
  
-@@ -873,19 +885,33 @@ namespace __format
+@@ -873,19 +875,33 @@ namespace __format
  
        template<typename _Tp, typename _FormatContext>
  	typename _FormatContext::iterator
@@ -441282,7 +444243,7 @@ new file mode 100644
  	  return __format::__write(std::move(__out), __sv);
  	}
  
-@@ -928,26 +954,39 @@ namespace __format
+@@ -928,26 +944,39 @@ namespace __format
  
        template<typename _Tp, typename _FormatContext>
  	typename _FormatContext::iterator
@@ -441335,7 +444296,7 @@ new file mode 100644
  	{
  	  if constexpr (chrono::__is_duration_v<_Tp>)
  	    {
-@@ -973,6 +1012,50 @@ namespace __format
+@@ -973,6 +1002,50 @@ namespace __format
  	    }
  	}
  
@@ -441386,16 +444347,41 @@ new file mode 100644
        template<typename _Tp, typename _FormatContext>
  	typename _FormatContext::iterator
  	_M_p(const _Tp& __t, typename _FormatContext::iterator __out,
-@@ -990,7 +1073,7 @@ namespace __format
+@@ -990,42 +1063,29 @@ namespace __format
  
        template<typename _Tp, typename _FormatContext>
  	typename _FormatContext::iterator
 -	_M_q(const _Tp& __t, typename _FormatContext::iterator __out,
+-	     _FormatContext& __ctx) const
 +	_M_q(const _Tp&, typename _FormatContext::iterator __out,
- 	     _FormatContext& __ctx) const
++	     _FormatContext&) const
  	{
  	  // %q The duration's unit suffix
-@@ -1020,12 +1103,15 @@ namespace __format
+ 	  if constexpr (!chrono::__is_duration_v<_Tp>)
+ 	    __throw_format_error("format error: argument is not a duration");
+ 	  else
+ 	    {
++	      namespace __d = chrono::__detail;
+ 	      using period = typename _Tp::period;
+-	      char __buf[sizeof("[/]s") + 2 * numeric_limits<intmax_t>::digits10];
+-	      constexpr size_t __n = sizeof(__buf);
+-	      auto __s = chrono::__detail::__units_suffix<period, _CharT>(__buf,
+-									  __n);
+-	      if constexpr (is_same_v<decltype(__s), const _CharT*>)
+-		return std::format_to(std::move(__out), _S_empty_spec, __s);
+-	      else
+-		{
+-		  // Suffix was written to __buf as narrow string.
+-		  _CharT __wbuf[__n];
+-		  size_t __len = __builtin_strlen(__buf);
+-		  locale __loc = _M_locale(__ctx);
+-		  auto& __ct = use_facet<ctype<_CharT>>(__loc);
+-		  __ct.widen(__buf, __len, __wbuf);
+-		  __wbuf[__len] = 0;
+-		  return std::format_to(std::move(__out), _S_empty_spec,
+-					__wbuf);
+-		}
++	      return __d::__fmt_units_suffix<period, _CharT>(std::move(__out));
  	    }
  	}
  
@@ -441412,7 +444398,7 @@ new file mode 100644
  	  locale __loc = _M_locale(__ctx);
  	  const auto& __tp = use_facet<__timepunct<_CharT>>(__loc);
  	  const _CharT* __ampm_fmt;
-@@ -1070,41 +1156,54 @@ namespace __format
+@@ -1070,41 +1130,54 @@ namespace __format
  	     _FormatContext& __ctx, bool __mod = false) const
  	{
  	  // %S  Seconds as a decimal number.
@@ -441489,7 +444475,7 @@ new file mode 100644
  		}
  	    }
  	  return __out;
-@@ -1121,14 +1220,21 @@ namespace __format
+@@ -1121,14 +1194,21 @@ namespace __format
  	  // %Ou Locale's alternative numeric rep.
  	  // %w  Weekday as a decimal number (0-6), where Sunday is 0.
  	  // %Ow Locale's alternative numeric rep.
@@ -441516,7 +444502,7 @@ new file mode 100644
  	}
  
        template<typename _Tp, typename _FormatContext>
-@@ -1146,6 +1252,18 @@ namespace __format
+@@ -1146,6 +1226,18 @@ namespace __format
  	  auto __d = _S_days(__t);
  	  using _TDays = decltype(__d); // Either sys_days or local_days.
  
@@ -441535,7 +444521,7 @@ new file mode 100644
  	  _TDays __first; // First day of week 1.
  	  if (__conv == 'V') // W01 begins on Monday before first Thursday.
  	    {
-@@ -1167,9 +1285,6 @@ namespace __format
+@@ -1167,9 +1259,6 @@ namespace __format
  	    }
  	  auto __weeks = chrono::floor<weeks>(__d - __first);
  	  __string_view __sv = _S_two_digits(__weeks.count() + 1);
@@ -441545,7 +444531,7 @@ new file mode 100644
  	  return __format::__write(std::move(__out), __sv);
  	}
  
-@@ -1197,11 +1312,12 @@ namespace __format
+@@ -1197,11 +1286,12 @@ namespace __format
  
        template<typename _Tp, typename _FormatContext>
  	typename _FormatContext::iterator
@@ -441559,7 +444545,7 @@ new file mode 100644
  	  locale __loc = _M_locale(__ctx);
  	  const auto& __tp = use_facet<__timepunct<_CharT>>(__loc);
  	  const _CharT* __time_reps[2];
-@@ -1220,7 +1336,7 @@ namespace __format
+@@ -1220,7 +1310,7 @@ namespace __format
        template<typename _Tp, typename _FormatContext>
  	typename _FormatContext::iterator
  	_M_z(const _Tp& __t, typename _FormatContext::iterator __out,
@@ -441568,19 +444554,33 @@ new file mode 100644
  	{
  	  using ::std::chrono::__detail::__utc_leap_second;
  	  using ::std::chrono::__detail::__local_time_fmt;
-@@ -1284,9 +1400,9 @@ namespace __format
+@@ -1278,18 +1368,18 @@ namespace __format
+ 	    {
+ 	      if (__t._M_abbrev)
+ 		{
+-		  __string_view __wsv;
++		  string_view __sv = *__t._M_abbrev;
+ 		  if constexpr (is_same_v<_CharT, char>)
+-		    __wsv = *__t._M_abbrev;
++		    return __format::__write(std::move(__out), __sv);
  		  else
  		    {
- 		      string_view __sv = *__t._M_abbrev;
+-		      string_view __sv = *__t._M_abbrev;
 -		      basic_string<_CharT> __ws(__sv.size());
++		      // TODO use resize_and_overwrite
 +		      basic_string<_CharT> __ws(__sv.size(), _CharT());
  		      auto& __ct = use_facet<ctype<_CharT>>(_M_locale(__ctx));
 -		      __ct.widen(__sv.data(), __sv.size(), __ws.data());
+-		      __wsv = __ws;
 +		      __ct.widen(__sv.begin(), __sv.end(), __ws.data());
- 		      __wsv = __ws;
++		      __string_view __wsv = __ws;
++		      return __format::__write(std::move(__out), __wsv);
  		    }
- 		  return __format::__write(std::move(__out), __wsv);
-@@ -1324,39 +1440,6 @@ namespace __format
+-		  return __format::__write(std::move(__out), __wsv);
+ 		}
+ 	    }
+ 	  else if constexpr (__is_specialization_of<_Tp, __utc_leap_second>)
+@@ -1324,39 +1414,6 @@ namespace __format
  	};
        }
  
@@ -441620,7 +444620,7 @@ new file mode 100644
        // Accessors for the components of chrono types:
  
        // Returns a hh_mm_ss.
-@@ -1485,6 +1568,48 @@ namespace __format
+@@ -1485,6 +1542,48 @@ namespace __format
  	  else
  	    return weekday(_S_days(__t));
  	}
@@ -441669,7 +444669,7 @@ new file mode 100644
      };
  
  } // namespace __format
-@@ -1835,7 +1960,13 @@ namespace __format
+@@ -1835,7 +1934,13 @@ namespace __format
        template<typename _ParseContext>
  	constexpr typename _ParseContext::iterator
  	parse(_ParseContext& __pc)
@@ -441684,7 +444684,7 @@ new file mode 100644
  
        template<typename _FormatContext>
  	typename _FormatContext::iterator
-@@ -1844,6 +1975,10 @@ namespace __format
+@@ -1844,6 +1949,10 @@ namespace __format
  	{ return _M_f._M_format(__t, __fc); }
  
      private:
@@ -441695,7 +444695,7 @@ new file mode 100644
        __format::__formatter_chrono<_CharT> _M_f;
      };
  
-@@ -2060,7 +2195,8 @@ namespace chrono
+@@ -2060,7 +2169,8 @@ namespace chrono
        _Str __s = _GLIBCXX_WIDEN("{:02d} is not a valid day");
        if (__d.ok())
  	__s = __s.substr(0, 6);
@@ -441705,7 +444705,7 @@ new file mode 100644
        return __os;
      }
  
-@@ -2078,8 +2214,10 @@ namespace chrono
+@@ -2078,8 +2188,10 @@ namespace chrono
  	__os << std::vformat(__os.getloc(), __s.substr(0, 6),
  			     make_format_args<_Ctx>(__m));
        else
@@ -441718,7 +444718,7 @@ new file mode 100644
        return __os;
      }
  
-@@ -2118,8 +2256,10 @@ namespace chrono
+@@ -2118,8 +2230,10 @@ namespace chrono
  	__os << std::vformat(__os.getloc(), __s.substr(0, 6),
  			     make_format_args<_Ctx>(__wd));
        else
@@ -442406,6 +445406,61 @@ new file mode 100644
      { return false; }
  #endif
  
+--- a/src/libstdc++-v3/include/debug/safe_iterator.tcc
++++ b/src/libstdc++-v3/include/debug/safe_iterator.tcc
+@@ -86,6 +86,9 @@ namespace __gnu_debug
+     _Safe_iterator<_Iterator, _Sequence, _Category>::
+     _M_can_advance(difference_type __n, bool __strict) const
+     {
++      if (this->_M_value_initialized() && __n == 0)
++	return true;
++
+       if (this->_M_singular())
+ 	return false;
+ 
+@@ -194,6 +197,12 @@ namespace __gnu_debug
+ 		   std::pair<difference_type, _Distance_precision>& __dist,
+ 		   bool __check_dereferenceable) const
+     {
++      if (_M_value_initialized() && __rhs._M_value_initialized())
++	{
++	  __dist = std::make_pair(0, __dp_exact);
++	  return true;
++	}
++
+       if (_M_singular() || __rhs._M_singular() || !_M_can_compare(__rhs))
+ 	return false;
+ 
+@@ -218,6 +227,12 @@ namespace __gnu_debug
+ 		   std::pair<difference_type,
+ 			     _Distance_precision>& __dist) const
+     {
++      if (this->_M_value_initialized() && __rhs._M_value_initialized())
++	{
++	  __dist = std::make_pair(0, __dp_exact);
++	  return true;
++	}
++
+       if (this->_M_singular() || __rhs._M_singular()
+ 	  || !this->_M_can_compare(__rhs))
+ 	return false;
+--- a/src/libstdc++-v3/include/debug/safe_local_iterator.tcc
++++ b/src/libstdc++-v3/include/debug/safe_local_iterator.tcc
+@@ -78,7 +78,13 @@ namespace __gnu_debug
+     _M_valid_range(const _Safe_local_iterator& __rhs,
+ 		std::pair<difference_type, _Distance_precision>& __dist) const
+     {
+-      if (!_M_can_compare(__rhs))
++      if (_M_value_initialized() && __rhs._M_value_initialized())
++	{
++	  __dist = { 0, __dp_exact };
++	  return true;
++	}
++
++      if (_M_singular() || __rhs._M_singular() || !_M_can_compare(__rhs))
+ 	return false;
+ 
+       if (bucket() != __rhs.bucket())
 --- a/src/libstdc++-v3/include/experimental/bits/fs_path.h
 +++ b/src/libstdc++-v3/include/experimental/bits/fs_path.h
 @@ -1042,7 +1042,7 @@ namespace __detail
@@ -443896,6 +446951,17 @@ new file mode 100644
  	{ }
  
        template<typename _Allocator>
+--- a/src/libstdc++-v3/include/std/iterator
++++ b/src/libstdc++-v3/include/std/iterator
+@@ -67,7 +67,7 @@
+ #endif
+ #include <bits/range_access.h>
+ 
+-#if __cplusplus >= 201402L && ! defined _GLIBCXX_DEBUG // PR libstdc++/70303
++#if __cplusplus >= 201402L
+ # define __cpp_lib_null_iterators 201304L
+ #endif
+ 
 --- a/src/libstdc++-v3/include/std/optional
 +++ b/src/libstdc++-v3/include/std/optional
 @@ -138,7 +138,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
@@ -444490,6 +447556,34 @@ new file mode 100644
  		    const _Tuple_impl<_Idx, _UHead>&& __in)
  	: _Base(__use_alloc<_Head, _Alloc, const _UHead>(__a),
  		std::forward<const _UHead>(_Tuple_impl<_Idx, _UHead>::_M_head(__in)))
+@@ -971,6 +971,13 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
+ 	tuple(allocator_arg_t __tag, const _Alloc& __a)
+ 	: _Inherited(__tag, __a) { }
+ 
++      template<typename _Alloc,
++	       _ExplicitDefaultCtor<is_object<_Alloc>::value> = false>
++	_GLIBCXX20_CONSTEXPR
++	explicit
++	tuple(allocator_arg_t __tag, const _Alloc& __a)
++	: _Inherited(__tag, __a) { }
++
+       template<typename _Alloc, bool _NotEmpty = (sizeof...(_Elements) >= 1),
+ 	       _ImplicitCtor<_NotEmpty, const _Elements&...> = true>
+ 	_GLIBCXX20_CONSTEXPR
+@@ -1453,6 +1460,13 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
+ 	tuple(allocator_arg_t __tag, const _Alloc& __a)
+ 	: _Inherited(__tag, __a) { }
+ 
++      template<typename _Alloc,
++	       _ExplicitDefaultCtor<is_object<_Alloc>::value, _T1, _T2> = false>
++	_GLIBCXX20_CONSTEXPR
++	explicit
++	tuple(allocator_arg_t __tag, const _Alloc& __a)
++	: _Inherited(__tag, __a) { }
++
+       template<typename _Alloc, bool _Dummy = true,
+ 	       _ImplicitCtor<_Dummy, const _T1&, const _T2&> = true>
+ 	_GLIBCXX20_CONSTEXPR
 --- a/src/libstdc++-v3/include/std/type_traits
 +++ b/src/libstdc++-v3/include/std/type_traits
 @@ -3359,8 +3359,13 @@ template <typename _Tp>
@@ -444666,7 +447760,18 @@ new file mode 100644
      }
 --- a/src/libstdc++-v3/include/std/version
 +++ b/src/libstdc++-v3/include/std/version
-@@ -294,7 +294,8 @@
+@@ -81,9 +81,7 @@
+ #define __cpp_lib_integral_constant_callable 201304L
+ #define __cpp_lib_is_final 201402L
+ #define __cpp_lib_make_reverse_iterator 201402L
+-#ifndef _GLIBCXX_DEBUG // PR libstdc++/70303
+-# define __cpp_lib_null_iterators 201304L
+-#endif
++#define __cpp_lib_null_iterators 201304L
+ #define __cpp_lib_robust_nonmodifying_seq_ops 201304L
+ #define __cpp_lib_transformation_trait_aliases 201304L
+ #define __cpp_lib_transparent_operators 201510L
+@@ -294,7 +292,8 @@
  #endif
  #define __cpp_lib_constexpr_vector 201907L
  #define __cpp_lib_erase_if 202002L
@@ -454513,6 +457618,25 @@ new file mode 100644
 +#endif
 +
 +// { dg-error "static assertion failed" "" { target *-*-* } 0 }
+new file mode 100644
+--- /dev/null
++++ b/src/libstdc++-v3/testsuite/20_util/tuple/cons/114147.cc
+@@ -0,0 +1,15 @@
++// { dg-do compile { target c++11 } }
++
++// PR libstdc++/114147
++// tuple allocator-extended ctor requires non-explicit default ctor
++
++#include <tuple>
++#include <memory>
++
++struct X { explicit X(); };
++
++std::allocator<int> a;
++std::tuple<X> t0(std::allocator_arg, a);
++std::tuple<int, X> t1(std::allocator_arg, a);
++std::tuple<X, int> t2(std::allocator_arg, a);
++std::tuple<int, X, int> t3(std::allocator_arg, a);
 --- a/src/libstdc++-v3/testsuite/20_util/uses_allocator/lwg3677.cc
 +++ b/src/libstdc++-v3/testsuite/20_util/uses_allocator/lwg3677.cc
 @@ -1,4 +1,4 @@
@@ -454767,6 +457891,26 @@ new file mode 100644
 +  I it2{};
 +  (void)(it1 == it2);
 +}
+new file mode 100644
+--- /dev/null
++++ b/src/libstdc++-v3/testsuite/23_containers/set/debug/114316.cc
+@@ -0,0 +1,16 @@
++// { dg-do run { target c++11 } }
++// { dg-require-debug-mode "" }
++
++// PR libstdc++/114316
++
++#include <set>
++#include <algorithm>
++
++#include <testsuite_hooks.h>
++
++int main()
++{
++  std::set<int>::iterator it{};
++  VERIFY( std::find(it, it, 0) == it );
++  return 0;
++}
 --- a/src/libstdc++-v3/testsuite/23_containers/span/back_assert_neg.cc
 +++ b/src/libstdc++-v3/testsuite/23_containers/span/back_assert_neg.cc
 @@ -26,5 +26,5 @@
@@ -455276,6 +458420,38 @@ new file mode 100644
  // { dg-do run { target c++20 } }
  
  #include <unordered_set>
+new file mode 100644
+--- /dev/null
++++ b/src/libstdc++-v3/testsuite/23_containers/unordered_set/debug/114316.cc
+@@ -0,0 +1,28 @@
++// { dg-do run { target c++11 } }
++// { dg-require-debug-mode "" }
++
++// PR libstdc++/114316
++
++#include <unordered_set>
++#include <algorithm>
++
++#include <testsuite_hooks.h>
++
++void test01()
++{
++  std::unordered_set<int>::iterator it{};
++  VERIFY( std::find(it, it, 0) == it );
++}
++
++void test02()
++{
++  std::unordered_set<int>::local_iterator it{};
++  VERIFY( std::find(it, it, 0) == it );
++}
++
++int main()
++{
++  test01();
++  test02();
++  return 0;
++}
 --- a/src/libstdc++-v3/testsuite/23_containers/unordered_set/operations/1.cc
 +++ b/src/libstdc++-v3/testsuite/23_containers/unordered_set/operations/1.cc
 @@ -15,6 +15,7 @@
@@ -455304,6 +458480,26 @@ new file mode 100644
 +{
 +  byCallSpread = {true};
 +}
+new file mode 100644
+--- /dev/null
++++ b/src/libstdc++-v3/testsuite/23_containers/vector/debug/114316.cc
+@@ -0,0 +1,16 @@
++// { dg-do run { target c++11 } }
++// { dg-require-debug-mode "" }
++
++// PR libstdc++/114316
++
++#include <vector>
++#include <algorithm>
++
++#include <testsuite_hooks.h>
++
++int main()
++{
++  std::vector<int>::iterator it{};
++  VERIFY( std::find(it, it, 0) == it );
++  return 0;
++}
 --- a/src/libstdc++-v3/testsuite/23_containers/vector/debug/assign4_backtrace_neg.cc
 +++ b/src/libstdc++-v3/testsuite/23_containers/vector/debug/assign4_backtrace_neg.cc
 @@ -1,5 +1,5 @@
@@ -455313,6 +458509,26 @@ new file mode 100644
  // { dg-require-effective-target stacktrace }
  
  #include <debug/vector>
+new file mode 100644
+--- /dev/null
++++ b/src/libstdc++-v3/testsuite/23_containers/vector/debug/n3644.cc
+@@ -0,0 +1,16 @@
++// { dg-do run { target c++11 } }
++// { dg-require-debug-mode "" }
++
++#include <vector>
++#include <algorithm>
++
++#include <testsuite_hooks.h>
++
++int main()
++{
++  std::vector<int>::iterator it{};
++  auto cpy = it;
++  std::advance(it, 0);
++  VERIFY( it == cpy );
++  return 0;
++}
 --- a/src/libstdc++-v3/testsuite/24_iterators/move_iterator/p2520r0.cc
 +++ b/src/libstdc++-v3/testsuite/24_iterators/move_iterator/p2520r0.cc
 @@ -1,5 +1,6 @@
@@ -455920,6 +459136,32 @@ new file mode 100644
  
    __builtin_puts("");
    return 0;			// Mark SPOT
+--- a/src/libstdc++-v3/testsuite/libstdc++-prettyprinters/cxx11.cc
++++ b/src/libstdc++-v3/testsuite/libstdc++-prettyprinters/cxx11.cc
+@@ -63,6 +63,11 @@ struct datum
+ 
+ std::unique_ptr<datum> global;
+ 
++struct custom_cat : std::error_category {
++  const char* name() const noexcept { return "miaow"; }
++  std::string message(int) const { return ""; }
++};
++
+ int
+ main()
+ {
+@@ -179,10 +184,7 @@ main()
+   std::error_condition ecinval = std::make_error_condition(std::errc::invalid_argument);
+   // { dg-final { note-test ecinval {std::error_condition = {"generic": EINVAL}} } }
+ 
+-  struct custom_cat : std::error_category {
+-    const char* name() const noexcept { return "miaow"; }
+-    std::string message(int) const { return ""; }
+-  } cat;
++  custom_cat cat;
+   std::error_code emiaow(42, cat);
+   // { dg-final { note-test emiaow {std::error_code = {custom_cat: 42}} } }
+   std::error_condition ecmiaow(42, cat);
 --- a/src/libstdc++-v3/testsuite/libstdc++-prettyprinters/cxx17.cc
 +++ b/src/libstdc++-v3/testsuite/libstdc++-prettyprinters/cxx17.cc
 @@ -50,18 +50,18 @@ main()
diff -pruN 13.2.0-19/debian/patches/libgnat-timet64.diff 13.2.0-20/debian/patches/libgnat-timet64.diff
--- 13.2.0-19/debian/patches/libgnat-timet64.diff	2024-02-22 01:30:48.000000000 +0000
+++ 13.2.0-20/debian/patches/libgnat-timet64.diff	1970-01-01 00:00:00.000000000 +0000
@@ -1,11 +0,0 @@
---- a/src/gcc/ada/libgnat/s-parame.ads
-+++ b/src/gcc/ada/libgnat/s-parame.ads
-@@ -102,7 +102,7 @@
-    -- Characteristics of time_t type --
-    ------------------------------------
- 
--   time_t_bits : constant := Long_Integer'Size;
-+   time_t_bits : constant := Long_Long_Integer'Size;
-    --  Number of bits in type time_t
- 
-    ----------------------------------------------
diff -pruN 13.2.0-19/debian/patches/libsanitizer-no-crypt.diff 13.2.0-20/debian/patches/libsanitizer-no-crypt.diff
--- 13.2.0-19/debian/patches/libsanitizer-no-crypt.diff	1970-01-01 00:00:00.000000000 +0000
+++ 13.2.0-20/debian/patches/libsanitizer-no-crypt.diff	2024-03-23 10:38:07.000000000 +0000
@@ -0,0 +1,132 @@
+# DP: libsanitzer: Remove crypt and crypt_r interceptors.
+
+From 9b116160a1482c5c0c199f9c21d78a527d11d9ea Mon Sep 17 00:00:00 2001
+From: Fangrui Song <i@maskray.me>
+Date: Fri, 28 Apr 2023 09:59:17 -0700
+Subject: [PATCH] Remove crypt and crypt_r interceptors
+
+From Florian Weimer's D144073
+
+> On GNU/Linux (glibc), the crypt and crypt_r functions are not part of the main shared object (libc.so.6), but libcrypt (with multiple possible sonames). The sanitizer libraries do not depend on libcrypt, so it can happen that during sanitizer library initialization, no real implementation will be found because the crypt, crypt_r functions are not present in the process image (yet). If its interceptors are called nevertheless, this results in a call through a null pointer when the sanitizer library attempts to forward the call to the real implementation.
+>
+> Many distributions have already switched to libxcrypt, a library that is separate from glibc and that can be build with sanitizers directly (avoiding the need for interceptors). This patch disables building the interceptor for glibc targets.
+
+Let's remove crypt and crypt_r interceptors (D68431) to fix issues with
+newer glibc.
+
+For older glibc, msan will not know that an uninstrumented crypt_r call
+initializes `data`, so there is a risk for false positives. However, with some
+codebase survey, I think crypt_r uses are very few and the call sites typically
+have a `memset(&data, 0, sizeof(data));` anyway.
+
+Fix https://github.com/google/sanitizers/issues/1365
+Related: https://bugzilla.redhat.com/show_bug.cgi?id=2169432
+
+Reviewed By: #sanitizers, fweimer, thesamesam, vitalybuka
+
+Differential Revision: https://reviews.llvm.org/D149403
+---
+ .../sanitizer_common_interceptors.inc         | 37 -------------------
+ .../sanitizer_platform_interceptors.h         |  2 -
+ .../sanitizer_platform_limits_posix.cpp       |  8 ----
+ .../sanitizer_platform_limits_posix.h         |  1 -
+ 4 files changed, 48 deletions(-)
+
+--- a/src/libsanitizer/sanitizer_common/sanitizer_common_interceptors.inc
++++ b/src/libsanitizer/sanitizer_common/sanitizer_common_interceptors.inc
+@@ -10187,41 +10187,6 @@ INTERCEPTOR(SSIZE_T, getrandom, void *buf, SIZE_T buflen, unsigned int flags) {
+ #define INIT_GETRANDOM
+ #endif
+ 
+-#if SANITIZER_INTERCEPT_CRYPT
+-INTERCEPTOR(char *, crypt, char *key, char *salt) {
+-  void *ctx;
+-  COMMON_INTERCEPTOR_ENTER(ctx, crypt, key, salt);
+-  COMMON_INTERCEPTOR_READ_RANGE(ctx, key, internal_strlen(key) + 1);
+-  COMMON_INTERCEPTOR_READ_RANGE(ctx, salt, internal_strlen(salt) + 1);
+-  char *res = REAL(crypt)(key, salt);
+-  if (res != nullptr)
+-    COMMON_INTERCEPTOR_INITIALIZE_RANGE(res, internal_strlen(res) + 1);
+-  return res;
+-}
+-#define INIT_CRYPT COMMON_INTERCEPT_FUNCTION(crypt);
+-#else
+-#define INIT_CRYPT
+-#endif
+-
+-#if SANITIZER_INTERCEPT_CRYPT_R
+-INTERCEPTOR(char *, crypt_r, char *key, char *salt, void *data) {
+-  void *ctx;
+-  COMMON_INTERCEPTOR_ENTER(ctx, crypt_r, key, salt, data);
+-  COMMON_INTERCEPTOR_READ_RANGE(ctx, key, internal_strlen(key) + 1);
+-  COMMON_INTERCEPTOR_READ_RANGE(ctx, salt, internal_strlen(salt) + 1);
+-  char *res = REAL(crypt_r)(key, salt, data);
+-  if (res != nullptr) {
+-    COMMON_INTERCEPTOR_WRITE_RANGE(ctx, data,
+-                                   __sanitizer::struct_crypt_data_sz);
+-    COMMON_INTERCEPTOR_INITIALIZE_RANGE(res, internal_strlen(res) + 1);
+-  }
+-  return res;
+-}
+-#define INIT_CRYPT_R COMMON_INTERCEPT_FUNCTION(crypt_r);
+-#else
+-#define INIT_CRYPT_R
+-#endif
+-
+ #if SANITIZER_INTERCEPT_GETENTROPY
+ INTERCEPTOR(int, getentropy, void *buf, SIZE_T buflen) {
+   void *ctx;
+@@ -10772,8 +10737,6 @@ static void InitializeCommonInterceptors() {
+   INIT_GETUSERSHELL;
+   INIT_SL_INIT;
+   INIT_GETRANDOM;
+-  INIT_CRYPT;
+-  INIT_CRYPT_R;
+   INIT_GETENTROPY;
+   INIT_QSORT;
+   INIT_QSORT_R;
+--- a/src/libsanitizer/sanitizer_common/sanitizer_platform_interceptors.h
++++ b/src/libsanitizer/sanitizer_common/sanitizer_platform_interceptors.h
+@@ -571,8 +571,6 @@
+ #define SANITIZER_INTERCEPT_FDEVNAME SI_FREEBSD
+ #define SANITIZER_INTERCEPT_GETUSERSHELL (SI_POSIX && !SI_ANDROID)
+ #define SANITIZER_INTERCEPT_SL_INIT (SI_FREEBSD || SI_NETBSD)
+-#define SANITIZER_INTERCEPT_CRYPT (SI_POSIX && !SI_ANDROID)
+-#define SANITIZER_INTERCEPT_CRYPT_R (SI_LINUX && !SI_ANDROID)
+ 
+ #define SANITIZER_INTERCEPT_GETRANDOM \
+   ((SI_LINUX && __GLIBC_PREREQ(2, 25)) || SI_FREEBSD)
+--- a/src/libsanitizer/sanitizer_common/sanitizer_platform_limits_posix.cpp
++++ b/src/libsanitizer/sanitizer_common/sanitizer_platform_limits_posix.cpp
+@@ -176,10 +176,6 @@ typedef struct user_fpregs elf_fpregset_t;
+ #  include "sanitizer_platform_interceptors.h"
+ #  include "sanitizer_platform_limits_posix.h"
+ 
+-#if SANITIZER_INTERCEPT_CRYPT_R
+-#include <crypt.h>
+-#endif
+-
+ namespace __sanitizer {
+   unsigned struct_utsname_sz = sizeof(struct utsname);
+   unsigned struct_stat_sz = sizeof(struct stat);
+@@ -283,10 +279,6 @@ namespace __sanitizer {
+   unsigned struct_statvfs64_sz = sizeof(struct statvfs64);
+ #endif // SANITIZER_LINUX && !SANITIZER_ANDROID
+ 
+-#if SANITIZER_INTERCEPT_CRYPT_R
+-  unsigned struct_crypt_data_sz = sizeof(struct crypt_data);
+-#endif
+-
+ #if SANITIZER_LINUX && !SANITIZER_ANDROID
+   unsigned struct_timex_sz = sizeof(struct timex);
+   unsigned struct_msqid_ds_sz = sizeof(struct msqid_ds);
+--- a/src/libsanitizer/sanitizer_common/sanitizer_platform_limits_posix.h
++++ b/src/libsanitizer/sanitizer_common/sanitizer_platform_limits_posix.h
+@@ -319,7 +319,6 @@ extern unsigned struct_msqid_ds_sz;
+ extern unsigned struct_mq_attr_sz;
+ extern unsigned struct_timex_sz;
+ extern unsigned struct_statvfs_sz;
+-extern unsigned struct_crypt_data_sz;
+ #endif  // SANITIZER_LINUX && !SANITIZER_ANDROID
+ 
+ struct __sanitizer_iovec {
diff -pruN 13.2.0-19/debian/patches/pr114065-proposed.diff 13.2.0-20/debian/patches/pr114065-proposed.diff
--- 13.2.0-19/debian/patches/pr114065-proposed.diff	1970-01-01 00:00:00.000000000 +0000
+++ 13.2.0-20/debian/patches/pr114065-proposed.diff	2024-03-23 10:38:07.000000000 +0000
@@ -0,0 +1,52 @@
+# DP: Fix PR ada/114064, 64bit definitions for time type for 32bit archs
+
+--- a/src/gcc/ada/Makefile.rtl
++++ b/src/gcc/ada/Makefile.rtl
+@@ -2122,6 +2122,7 @@ ifeq ($(strip $(filter-out mips% linux%,$(target_cpu) $(target_os))),)
+   s-osinte.adb<libgnarl/s-osinte__posix.adb \
+   s-osinte.ads<libgnarl/s-osinte__linux.ads \
+   s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-parame.ads<libgnat/s-parame__posix2008.ads \
+   s-taprop.adb<libgnarl/s-taprop__linux.adb \
+   s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
+   s-tasinf.adb<libgnarl/s-tasinf__linux.adb \
+@@ -2165,6 +2166,7 @@ ifeq ($(strip $(filter-out powerpc% linux%,$(target_cpu) $(target_os))),)
+   s-intman.adb<libgnarl/s-intman__posix.adb \
+   s-linux.ads<libgnarl/s-linux.ads \
+   s-osinte.adb<libgnarl/s-osinte__posix.adb \
++  s-parame.ads<libgnat/s-parame__posix2008.ads \
+   s-tpopsp.adb<libgnarl/s-tpopsp__tls.adb \
+   s-mudido.adb<libgnarl/s-mudido__affinity.adb \
+   s-osinte.ads<libgnarl/s-osinte__linux.ads \
+@@ -2214,6 +2216,7 @@ ifeq ($(strip $(filter-out arm% linux-gnueabi%,$(target_cpu) $(target_os))),)
+   s-osinte.adb<libgnarl/s-osinte__posix.adb \
+   s-osinte.ads<libgnarl/s-osinte__linux.ads \
+   s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-parame.ads<libgnat/s-parame__posix2008.ads \
+   s-taprop.adb<libgnarl/s-taprop__linux.adb \
+   s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
+   s-tasinf.adb<libgnarl/s-tasinf__linux.adb \
+@@ -2325,6 +2328,7 @@ ifeq ($(strip $(filter-out hppa% linux%,$(target_cpu) $(target_os))),)
+   s-osinte.adb<libgnarl/s-osinte__posix.adb \
+   s-osinte.ads<libgnarl/s-osinte__linux.ads \
+   s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-parame.ads<libgnat/s-parame__posix2008.ads \
+   s-taprop.adb<libgnarl/s-taprop__linux.adb \
+   s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
+   s-tasinf.adb<libgnarl/s-tasinf__linux.adb \
+@@ -2352,6 +2356,7 @@ ifeq ($(strip $(filter-out m68k% linux%,$(target_cpu) $(target_os))),)
+   s-osinte.adb<libgnarl/s-osinte__posix.adb \
+   s-osinte.ads<libgnarl/s-osinte__linux.ads \
+   s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-parame.ads<libgnat/s-parame__posix2008.ads \
+   s-taprop.adb<libgnarl/s-taprop__linux.adb \
+   s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
+   s-tasinf.adb<libgnarl/s-tasinf__linux.adb \
+@@ -2379,6 +2384,7 @@ ifeq ($(strip $(filter-out sh4% linux%,$(target_cpu) $(target_os))),)
+   s-osinte.adb<libgnarl/s-osinte__posix.adb \
+   s-osinte.ads<libgnarl/s-osinte__linux.ads \
+   s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-parame.ads<libgnat/s-parame__posix2008.ads \
+   s-taprop.adb<libgnarl/s-taprop__linux.adb \
+   s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
+   s-tasinf.adb<libgnarl/s-tasinf__linux.adb \
diff -pruN 13.2.0-19/debian/rules.d/binary-libstdcxx.mk 13.2.0-20/debian/rules.d/binary-libstdcxx.mk
--- 13.2.0-19/debian/rules.d/binary-libstdcxx.mk	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-20/debian/rules.d/binary-libstdcxx.mk	2024-03-23 10:38:07.000000000 +0000
@@ -112,6 +112,7 @@ files_dev = \
 	$(PFL)/include/c++/$(BASE_VERSION) \
 	$(gcc_lib_dir)/libstdc++.{a,so} \
 	$(gcc_lib_dir)/libsupc++.a \
+	$(gcc_lib_dir)/libstdc++_libbacktrace.a \
 	$(gcc_lib_dir)/libstdc++fs.a \
 	$(gcc_lib_dir)/libstdc++exp.a
 
@@ -131,6 +132,7 @@ dirs_dbg = \
 files_dbg = \
 	$(usr_lib)/debug/libstdc++.{a,so*} \
 	$(usr_lib)/debug/libstdc++fs.a \
+	$(usr_lib)/debug/libstdc++_libbacktrace.a \
 	$(usr_lib)/debug/libstdc++exp.a
 
 dirs_pic = \
@@ -391,6 +393,7 @@ $(binary_stamp)-libstdcxx-dev: $(libcxxd
 	mv $(d)/$(usr_lib)/libsupc++.a $(d)/$(gcc_lib_dir)/
 	mv $(d)/$(usr_lib)/libstdc++fs.a $(d)/$(gcc_lib_dir)/
 	mv $(d)/$(usr_lib)/libstdc++exp.a $(d)/$(gcc_lib_dir)/
+	mv $(d)/$(usr_lib)/libstdc++_libbacktrace.a $(d)/$(gcc_lib_dir)/
 	mv $(d)/$(usr_lib)/libstdc++.{a,so} $(d)/$(gcc_lib_dir)/
 	ln -sf ../../../$(DEB_TARGET_GNU_TYPE)/libstdc++.so.$(CXX_SONAME) \
 		$(d)/$(gcc_lib_dir)/libstdc++.so
diff -pruN 13.2.0-19/debian/rules.parameters 13.2.0-20/debian/rules.parameters
--- 13.2.0-19/debian/rules.parameters	2024-03-15 02:20:11.000000000 +0000
+++ 13.2.0-20/debian/rules.parameters	2024-03-23 10:38:07.000000000 +0000
@@ -2,14 +2,14 @@
 GCC_VERSION	:= 13.2.0
 NEXT_GCC_VERSION	:= 13.2.1
 BASE_VERSION	:= 13
-SOURCE_VERSION	:= 13.2.0-19
-DEB_VERSION	:= 13.2.0-19
-DEB_EVERSION	:= 1:13.2.0-19
-DEB_GDC_VERSION	:= 13.2.0-19
+SOURCE_VERSION	:= 13.2.0-20
+DEB_VERSION	:= 13.2.0-20
+DEB_EVERSION	:= 1:13.2.0-20
+DEB_GDC_VERSION	:= 13.2.0-20
 DEB_SOVERSION	:= 5
 DEB_SOEVERSION	:= 1:5
 DEB_LIBGCC_SOVERSION	:= 
-DEB_LIBGCC_VERSION	:= 13.2.0-19
+DEB_LIBGCC_VERSION	:= 13.2.0-20
 DEB_STDCXX_SOVERSION	:= 5
 DEB_GOMP_SOVERSION	:= 5
 GCC_SONAME	:= 1
diff -pruN 13.2.0-19/debian/rules.patch 13.2.0-20/debian/rules.patch
--- 13.2.0-19/debian/rules.patch	2024-03-15 16:33:09.000000000 +0000
+++ 13.2.0-20/debian/rules.patch	2024-03-23 10:38:07.000000000 +0000
@@ -78,6 +78,12 @@ debian_patches += \
 	pr113030 \
 	libsanitizer-timebits \
 	asan-allocator-base \
+	gcc-vhdl \
+
+# with glibc (>= 2.31)
+ifeq (,$(filter $(distrelease),wheezy jessie stretch buster precise xenial bionic))
+  debian_patches += libsanitizer-no-crypt
+endif
 
 ifneq (,$(filter $(distrelease),lunar))
   debian_patches += rust-enabled
@@ -96,9 +102,7 @@ endif
 
 ifeq (,$(filter $(distrelease),$(no_timet64_distreleases)))
   debian_patches += pr99832-distro
-  ifneq (,$(filter $(DEB_TARGET_ARCH), $(timet64_archs)))
-    debian_patches += libgnat-timet64
-  endif
+  debian_patches += pr114065-proposed
 endif
 
 # TODO:
diff -pruN 13.2.0-19/debian/rules2 13.2.0-20/debian/rules2
--- 13.2.0-19/debian/rules2	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-20/debian/rules2	2024-03-23 10:38:07.000000000 +0000
@@ -1288,15 +1288,6 @@ endif
 	  mkdir -p $(builddir)/sys-include; \
 	  ln -sf /usr/include/$(DEB_TARGET_MULTIARCH)/asm $(builddir)/sys-include/asm; \
 	fi
-	: # Fall back to the host crypt.h when target is unavailable as the
-	: #sizeof(struct crypt_data) is unlikely to change, needed by libsanitizer.
-	if [ ! -f /usr/include/crypt.h ] && \
-		[ ! -f /usr/include/$(DEB_TARGET_MULTIARCH)/crypt.h ] && \
-		[ -f /usr/include/$(DEB_HOST_MULTIARCH)/crypt.h ]; then \
-	  mkdir -p $(builddir)/sys-include; \
-	  ln -sf /usr/include/$(DEB_HOST_MULTIARCH)/crypt.h \
-	    $(builddir)/sys-include/crypt.h; \
-	fi
 
 	touch $(configure_stamp)
 
